﻿// JScript File
registerNamespace("Custom.DataProvider");

Custom.DataProvider=function(p_elSource,p_htParams)
{
    Custom.DataProvider.initializeBase(this,arguments);
    var m_hlpr = new Web.UI.Utilities.CleanupHelper();
    var m_this=this;
    
    this.initialize=function(p_elOwner)
    {
        Custom.DataProvider.getBaseMethod(this,"initialize","Web.Bindings.Base").call(this,p_elOwner);
        this.registerFor("Live.EnhancedPreview",onEPBind,p_elSource);
    }
	
    this.dispose = function(p_blnDispose)
    {
        Custom.DataProvider.getBaseMethod(this,"dispose","Web.Bindings.Base").call(this,p_blnDispose);
        m_hlpr.dispose();
    }
    
    function onEPBind(ep)
    {
        function hover()
        {
            getData(ep);
        }
        m_hlpr.attachEvent(null,ep,"onhover",hover);
    }
    
    function getData(ep)
    {
        //ep.setBoundindArea(new Web.UI.Rect(0,0,100,100));
        setTimeout(setData,2000);
        function setData()
        {
            ep.setData(getPagePreview(ep.srcElement));
        }
    }
    
    function getPagePreview(el)
    {
        return {
            header:el.innerText,
            body:"body html goes here<br />lorem ipsum dolor sit amet, da di da.",
            actions:["<a href='#'>action 1</a>","<a href='#'>action 2</a>","<a href='#'>action 3</a>","<a href='#'>action 4</a>","<a href='#'>action 5</a>"]
        }
    }
}
Custom.DataProvider.registerClass("Custom.DataProvider","Web.Bindings.Base");
