//------------------------------------------------------------------------------
// Ads.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, sstchur
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Constructor - Creates a new Ad object
function Ad(title, url, description, latitude, longitude)
{
	this.title = title;
	this.url = url;
	this.description = description;
	this.latitude = latitude;
	this.longitude = longitude;
}

// Converts the add to an HTML string.  The HTML contains a link to the url with the title as part of
// the text.  The description is appended.
Ad.prototype.ToHtml=function()
{
	var li =
	'<li>' +
		'<a href = "' + this.url + '" target = "_blank">' + IOSec.EncodeHtml(this.title) + '</a>' +
		'$AdDescription$' +
	'</li>';
	
	if (this.description && this.description.length > 0)
		li = li.replace('$AdDescription$', '<p>' + IOSec.EncodeHtml(this.description) + '</p>');
		
	return li;
}
