
 //------------------------------------------------------------------------------
 // ./Details/Click2Call.js 
 //
 // <copyright from='2004' to='2005' company='Microsoft Corporation' >
 // Copyright (c) Microsoft Corporation. All Rights Reserved. 
 // Information Contained Herein is Proprietary and Confidential. 
 // </copyright>
 //
 // Owner: a-haowu
 //
 //  
 // <header>	$Header$</header>
 //------------------------------------------------------------------------------
 
 Click2CallEntryPoint =
 {
 	SearchResultPane0: 0,
 	SearchResultPane1: 1,
 	SearchResultPane2: 2,
 	SearchResultERO: 3,
 	BusinessListingERO: 4,
 	DetailsPage: 5
 };
 
 //avoid too many widgets created without cleanup
 WidgetsSize = 
 {
	SearchResultPane: 0,
	SearchResultERO: 1,
	BusinessListingERO: 1,
	DetailsPage: 2
 };
 
 var VE_Click2Call =
 {
 	SearchResultPane0Manager : null,
 	SearchResultPane1Manager : null,
 	SearchResultPane2Manager : null,
 	SearchResultEROManager : null,
 	BusinessListingEROManager : null,
 	DetailsPageManager : null, 	
 	
 	isAllowedCountry : function(country)
 	{
 		if (!country || country == '') return false;
 		var list = Msn.VE.Features.Click2Call.CountryList;
 		for (var i=0; i<list.length; i++)
 		{
 			if (list[i] == country) return true;
 		}
 		return false;
 	},
 	
 	setSearchResultPaneWidgetsSize : function(size)
 	{
 		WidgetsSize.SearchResultPane = size;
 	},
 	
	removeAllWidgets : function()
	{
		var Click2Call;
		Click2Call = VE_Click2Call.getClick2CallManager(Click2CallEntryPoint.SearchResultPane);
		Click2Call.DestroyAllWidgets();
		Click2Call = VE_Click2Call.getClick2CallManager(Click2CallEntryPoint.SearchResultERO);
		Click2Call.DestroyAllWidgets();
		Click2Call = VE_Click2Call.getClick2CallManager(Click2CallEntryPoint.BusinessListingERO);
		Click2Call.DestroyAllWidgets();
	},
	
 	getClick2CallManager : function(SceID)
 	{
 		switch (SceID)
 		{
 		case Click2CallEntryPoint.SearchResultPane0:
 			if (!VE_Click2Call.SearchResultPane0Manager)
 				VE_Click2Call.SearchResultPane0Manager = new Click2CallManager(Click2CallEntryPoint.SearchResultPane0, WidgetsSize.SearchResultPane);
 			return VE_Click2Call.SearchResultPane0Manager;
 			break;
 		case Click2CallEntryPoint.SearchResultPane1:
 			if (!VE_Click2Call.SearchResultPane1Manager)
 				VE_Click2Call.SearchResultPane1Manager = new Click2CallManager(Click2CallEntryPoint.SearchResultPane1, WidgetsSize.SearchResultPane);
 			return VE_Click2Call.SearchResultPane1Manager;
 			break;
 		case Click2CallEntryPoint.SearchResultPane2:
 			if (!VE_Click2Call.SearchResultPane2Manager)
 				VE_Click2Call.SearchResultPane2Manager = new Click2CallManager(Click2CallEntryPoint.SearchResultPane2, WidgetsSize.SearchResultPane);
 			return VE_Click2Call.SearchResultPane2Manager;
 			break;
 		case Click2CallEntryPoint.SearchResultERO:
 			if (!VE_Click2Call.SearchResultEROManager)
 				VE_Click2Call.SearchResultEROManager = new Click2CallManager(Click2CallEntryPoint.SearchResultERO, WidgetsSize.SearchResultERO);
 			return VE_Click2Call.SearchResultEROManager;
 			break;
 		case Click2CallEntryPoint.BusinessListingERO:
 			if (!VE_Click2Call.BusinessListingEROManager)
 				VE_Click2Call.BusinessListingEROManager = new Click2CallManager(Click2CallEntryPoint.BusinessListingERO, WidgetsSize.BusinessListingERO);
 			return VE_Click2Call.BusinessListingEROManager;
 			break;
 		case Click2CallEntryPoint.DetailsPage:
 			if (!VE_Click2Call.DetailsPageManager)
 				VE_Click2Call.DetailsPageManager = new Click2CallManager(Click2CallEntryPoint.DetailsPage, WidgetsSize.DetailsPage);
 			return VE_Click2Call.DetailsPageManager;
 			break;				
 		}
 		
 		function Click2CallManager(SceID, MaxWidgets)
 		{
 			var mpcWidgetManager;
 			var calls = new Array();
 			var ScenarioID = SceID; 			
 			var Widgets = new Array();
 			var widgetnumber = MaxWidgets;
 			
 			MPCall_SetWidgetGlobals("mpcallbaseurl", click2callurl);
			MPCall_SetWidgetGlobals("mpcallhigstate", 1); 			
			
 			mpcWidgetManager = new MPCall_WidgetManager('WLL', ScenarioID, window.locale, true);	 			 	
 			 	
 			try
 			{	
				mpcWidgetManager.Set("mpcwidgetclickcb", VE_Analytics.LogClick2Call);
				mpcWidgetManager.Set("mpcwidgetkpresscb", VE_Analytics.LogClick2Call); 			
			}
			catch(mpcerror)
			{
				//swallo
			}
 			
 			this.CreateWidget = function(mid, parentid)
 			{
 				var call = new Object();
 				call.mid = mid;
 				call.pid = parentid;
 				calls.push(call);
 			}
 			
 			this.RenderWidgets = function()
 			{
 				//this is not good. 225 and 335 are the height and width of the widget.
 				var top = (document.body.clientHeight - 225) / 2;
 				var left = (document.body.clientWidth - 335) / 2; 				
 				while (calls.length>0)
 				{
 					var call = calls.shift();
 					var mpc = new MPCall_Widget(call.mid, 2, L_CallForFress_Text, top, left);
 					_push(mpc);
 					mpc.SetParent(call.pid);
 					mpcWidgetManager.AddWidget(mpc);
 					call = null;
 				}
 			}
 			
 			this.CreateRenderWidget = function(mid, parentid)
 			{	
 				//this is not good. 225 and 335 are the height and width of the widget.
 				var top = (GetWindowHeight() - 225) / 2;
 				var left = (GetWindowWidth() - 335) / 2;
 				var mpc = new MPCall_Widget(mid, 2, L_CallForFress_Text, top, left);
 				_push(mpc); 				
 				mpc.SetParent(parentid);
 				mpcWidgetManager.AddWidget(mpc);
 			}
 			
 			function _push(mpc)
 			{
 			
 				if (Widgets.length == widgetnumber) 
 				{
 					var temp = Widgets.shift();

 					if(mpcWidgetManager.Destroy)
 					{
 						try{
 							mpcWidgetManager.Destroy(temp);
 						}
 						catch(e)
						{
							//swallow
						}
 					}
 				} 				
 				Widgets.push(mpc); 
 			}
 			
 			this.Destroy = function()
 			{
 				DestroyAllWidgets();
 				Widgets = null;
 				calls = null;
 			}
 			
 			this.DestroyAllWidgets = function()
 			{
 				while (Widgets.length>0)
 				{ 					
 					var mpc = Widgets.pop(); 					
 					if(mpcWidgetManager.Destroy)
 						mpcWidgetManager.Destroy(temp);					

 				} 				
 			}
 			
 		}	
 	}
 }