//------------------------------------------------------------------------------
// MapControl/Global.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

var offsetMeters = 20971520;
var baseMetersPerPixel = 163840;
	
var buffer = 0;
var animatedMovementEnabled = true;
var zoomTotalSteps = 6;
var keyboardPanSpeed = 15;
var panToLatLongSpeed = 15;
var earthRadius = 6378137;
var earthCircumference = earthRadius * 2.0 * Math.PI;
var projectionOffset = earthCircumference * 0.5;
var minZoom = 1;
var maxZoom = 19;
var emptyTile = "__emptyTile__";
var minLatitude = -85;
var maxLatitude = 85;
var minLongitude = -180;
var maxLongitude = 180;
var tileSize = 256;
var generations = new Object();

// Z-indexes 
var kbInputZIndex = 0;
var containerZIndex = 0;
var mapZIndex = 1;
var swapZIndex = 1;
var baseZIndex = 2;
var debugZIndex = 3;
var baseZIndex = 11;
var topZIndex = 20;
