//------------------------------------------------------------------------------
// Panel/Events.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Creates a new map control event
function VE_PanelEvent(srcPanel)
{
	this.srcPanel = srcPanel;
}


// Creates a new map control event based on the current map settings.
VE_Panel.prototype._CreateEvent=function()
{
	return new VE_PanelEvent(this);
}


// Handles the event of the title bar being clicked.
VE_Panel._OnTitleClick=function(e)
{
	if(!e) e = window.event;
	var t = GetTarget(e);	
	
	var p = VE_Panel.panels;
	
	for(var i=0; i<p.length; i++)
	{
		if(p[i].title == t || p[i].title == t.parentNode)
		{
			if(p[i].onTitleClick)
			{
				p[i].onTitleClick(p[i]._CreateEvent());
			}
			return;
		}
	}
}


// Handles the event of the close button being clicked.
VE_Panel._OnCloseClick=function(e)
{
	if(!e) e = window.event;
	var c = GetTarget(e);
	var p = VE_Panel.panels;
	
	for(var i=0; i<p.length; i++)
	{
		if(p[i].cb == c)
		{
			if(p[i].onCloseClick)
			{
				p[i].onCloseClick(p[i]._CreateEvent());
			}
			return;
		}
	}
}
