//------------------------------------------------------------------------------
// StateConstants.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: EShinn
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Cookie
//------------------------------------------------------------------------------
VE_State.CookieNameState = "VE_State";
VE_State.CookieNamePageLastVisited = "PageLastVisited";
VE_State.CookieNameSerializationVersion = "SerializationVersion";
VE_State.CookieNameSuffixPersistent = "Persistent";
VE_State.CookieNameSuffixSession = "Session";
VE_State.CookieExpDateEOT = new Date(4000, 12, 31, 23, 59); // End of time (as far as we're concerned)
VE_State.CookieNameCollectionId = "CollectionId";

//------------------------------------------------------------------------------
// Configuration Category 
//------------------------------------------------------------------------------
VE_State.CategorySystem = "System";
VE_State.CategoryDirections = "Directions";
VE_State.CategoryViewport = "Viewport";
VE_State.CategoryStartup = "Startup";
VE_State.CategorySearches = "Searches";
VE_State.CategoryScratchpad = "Scratchpad";
VE_State.CategoryUserOptionsExit = "UserOptionsExit";
VE_State.CategoryUserOptionsMap = "UserOptionsMap";
VE_State.CategoryUserOptionsSearch = "UserOptionsSearch";
VE_State.CategoryUserOptionsLocate = "UserOptionsLocate";
VE_State.CategoryTraffic = "Traffic";

//------------------------------------------------------------------------------
// Configuration Item
//------------------------------------------------------------------------------
VE_State.ItemCurrentUrlApiVersion = "CurrentUrlApiVersion";
VE_State.ItemWifiServiceUrl = "WifiServiceUrl";
VE_State.ItemWifiDownloadUrl = "WifiDownloadUrl";
VE_State.ItemMaxInputCount = "MaxInputCount";
VE_State.ItemAnalyticsEnabled = "AnalyticsEnabled";
VE_State.ItemCenterPoint = "cp";
VE_State.ItemMapStyle = "style";
VE_State.ItemZoom = "lvl";
VE_State.ItemScene = "scene";
VE_State.ItemSpecifiedUrlApiVersion = "v";
VE_State.ItemAutolocate = "autolocate";
VE_State.ItemStartWhere = "where1";
VE_State.ItemRoutePoints = "rtp";
VE_State.ItemCombinedQuery = "q";
VE_State.ItemSearches = "ss";
VE_State.ItemServerPageSize = "ServerPageSize";
VE_State.ItemMaxSearches = "MaxSearches";
VE_State.ItemScratchpadIds = "sp";
VE_State.ItemSaveLocation = "SaveLocation";
VE_State.ItemSaveSearches = "SaveSearches2";
VE_State.ItemSaveScratchpad = "SaveScratchpad";
VE_State.ItemSaveDirectionsUnit = "DirectionUnit";
VE_State.ItemAnimatedMovementsEnabled = "AnimatedMovementsEnabled";
VE_State.ItemClientPageSize = "ClientPageSize";
VE_State.ItemDontAskWiFiLocator = "DontAskWiFiLocator";
VE_State.ItemCollectionId	= "cid";
VE_State.ItemTraffic = "trfc";