// Copyright 2005 Microsoft Corporation
// Version number : 1.3.0519
//****************************************
//****************Resources***************
//****************************************

//Text
//JS/Directions/PrintableDirectionsManager.js
var L_PrintableDirectionsManagerMetaDescription_Text = "Welcome to %1, the best way to find what you're searching for. %1 has slick new features for online mapping and local search that you'll want to try!";// %1 is the Product name - Windows Live Local
var L_PrintableDirectionsManagerWindowTitle_Text = "%1 - Custom Print Options"; // %1 is the Product name - Windows Live Local
var L_PrintableDirectionsManagerDistance_Text = "Distance";
var L_PrintableDirectionsManagerDetailMap_Text = "Detail Map";
var L_PrintableDirectionsManagerMoreSteps_Text = "more steps...";
var L_PrintableDirectionsManagerTypeYourNotes_Text = "Enter your own notes here";
var L_PrintableDirectionsManagerPrintOptions_Text = "Custom Print Options";
var L_PrintableDirectionsManagerPresetPrintOptions_Text = "Predefined selections";
var L_PrintableDirectionsManagerPrintMapAndDirections_Text = "Map and text";
var L_PrintableDirectionsManagerPrintDirectionsOnly_Text = "Text only";
var L_PrintableDirectionsManagerPrintMapOnly_Text = "Map only";
var L_PrintableDirectionsManagerPrint_Text = "Print";
var L_PrintableDirectionsManagerCancel_Text = "Cancel";
var L_PrintableDirectionsManagerPrintRouteMap_Text = "Print the map";
var L_PrintableDirectionsManagerMapCoverage_Text = "Map coverage";
var L_PrintableDirectionsManagerMapSize_Text = "Map size"; 
var L_PrintableDirectionsManagerMapStyle_Text = "Map style";
var L_PrintableDirectionsManagerStart_Text = "Start";
var L_PrintableDirectionsManagerSmall_Text = "Small";
var L_PrintableDirectionsManagerRoad_Text = "Road";
var L_PrintableDirectionsManagerEnd_Text = "End";
var L_PrintableDirectionsManagerMedium_Text = "Medium";
var L_PrintableDirectionsManagerAerial_Text = "Aerial";
var L_PrintableDirectionsManagerEntireRoute_Text = "Entire route";
var L_PrintableDirectionsManagerLarge_Text = "Large";
var L_PrintableDirectionsManagerShowLabels_Text = "show labels";
var L_PrintableDirectionsManagerPrintRouteSummary_Text = "Print the route summary";
var L_PrintableDirectionsManagerTime_Text = "Time";
var L_PrintableDirectionsManagerPrintDirections_Text = "Print the directions";
var L_PrintableDirectionsManagerAll_Text = "All";
var L_PrintableDirectionsManagerShowInstructions_Text = "Show instructions";
var L_PrintableDirectionsManagerStartOnly_Text = "Start only";
var L_PrintableDirectionsManagerEndOnly_Text = "End only";
var L_PrintableDirectionsManagerDirectionControl_Text = "Use the check boxes next to each detail map to show or hide the map.";
var L_PrintableDirectionsManagerPrintMyNotes_Text = "Print my notes";
var L_PrintableDirectionsManagerDirections_Text = "Directions";
var L_PrintableDirectionsManagerPrintTheScratchPad_Text = "Print the scratch pad";
var L_PrintableDirectionsManagerPrintCollection_Text = "Print";
var L_PrintableDirectionsManagerPrintSearchResults_Text = "Print search results";
var L_PrintableDirectionsManagerScratchPadTitle_Text = "  Scratch pad";
var L_PrintableDirectionsManagerSearchTitle_Text = "  Results for";


//Images
var img_LogoMastHead = "i/logo_masthead.png";
//------------------------------------------------------------------------------
//	VE.Feature.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-pratin
//
// <header>	$Header$</header>
//-----------------------------------------------------------------------------
//Localizable Strings
var L_VEProductName_Text = "Windows Live Local";	

// RegisterNamespace
RegisterNamespaces("Msn.VE");

Msn.VE.Features = new function()
{
	// Product name 
	this.ProductName = L_VEProductName_Text;

	//Settings Dialog options
	this.Settings = new function()
	{
		this.SaveLastLocation = true; 
		this.SaveSearches = false; 
		this.SaveScratchpad = true; 
		this.UseAnimatedPanZoom = true; 
		this.InstallLocationFinderNotification = false; 
	}
	// Footer links
	this.Footer = new function()
	{
		this.About = true;
		this.Privacy = true;
		this.Developers = true;
		this.Help = true;
		this.Feedback = true;
	}
	
	//Header links
	this.Header = new function()
	{
		this.Help = true;
		this.Settings = true;
	}
	
	//Search categories
	this.Search = new function()
	{
		this.Categories = false;
	}
	
	//Map Action bar
	this.MapAction = new function()
	{
		this.Welcome = true;
		
		this.Collections = new function()
		{
			this.DisplayNone = false;
			this.Open = true;
			this.New = true;
			this.AddPushpin = (this.DisplayNone) ? false : true;
			this.Favorites = true;			
		}
		
		this.DrivingDirections = true;
		this.Traffic = false;	
		this.LocateMe = true;	
		
		this.Share = new function()
		{
			this.ShareInMessenger = true;			
			this.EmailPermalink = true;					// E-mail
			this.CopyToClipboard = true;			
			this.AddBlogEntry = true;
			this.ViewPermalink = true;
			this.DisplayNone = false;
		}
	}
	
	//Context menu / pop-up	
	this.MenuOption = new function()
	{
		this.ZoomToStreet = true;
		this.ZoomToCity = true;
		this.ZoomToRegion = true;
		this.CenterMapHere = true;
		this.SendEmailOnPushpinItem = true;
		this.SendEmailOnSearchItem = true;
		this.DetailsOnSearchItem = true;
	
		//Scratch Pad Panel menu	
		this.ShareScratchPadItems = new function()
		{
			this.SendIM = false;
			this.SendEmail = true;
			this.CopyToClipboard = true;
			this.AddBlogEntry = true;				
			this.DisplayNone = false;		
		}
		
		this.MapAllScratchPadItems = true;
		
		//Driving Direction Panel menu
		this.ShareDrivingDirections = new function()
		{
			this.SendEmail = true;
			this.CopyToClipboard = true;
			this.SendIM = true;
			this.DisplayNone = false;		
		}
		
		this.PrintDrivingDirections = new function()
		{
			this.Customized = true;			
			this.MapsAndDirectionsOnly = true; 
			this.MapsOnly = true;
			this.DirectionsOnly = true;			
			this.DisplayNone = false;		
		}
	}
	//Traffic flow Strings
	this.Traffic = new function()
	{
		this.Flow = new function()
		{
			this.Slow = "0-25 mph";
			this.Moderate = "25-45 mph";
			this.Fast = "45+ mph";
		}
		
		this.Attribution = "Traffic data provided by Traffic.com";
		
	}
	//Click2Call feature
	this.Click2Call = new function()
	{
		this.Enabled = false;
		this.CountryList = new Array();
	}
	
		this.Ads = new function()
	{	
		//Overture, Telco, OvertureCA, Thompson
		this.AttributionTextOverture = "Sponsors From Overture";
		this.AttributionTextTelco = "Sponsors From Superpages";
		this.AttributionTextOvertureCA = ""; //left blank intentionally
		this.AttributionTextThompson = "Sponsors from ThompsonLocal.com";
	}	

		
}

//------------------------------------------------------------------------------
// Directions/PrintableDirectionsManager.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: A-Bwrigh
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// MapControl/Global.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

var offsetMeters = 20971520;
var baseMetersPerPixel = 163840;
	
var buffer = 0;
var animatedMovementEnabled = true;
var zoomTotalSteps = 6;
var keyboardPanSpeed = 15;
var panToLatLongSpeed = 15;
var earthRadius = 6378137;
var earthCircumference = earthRadius * 2.0 * Math.PI;
var projectionOffset = earthCircumference * 0.5;
var minZoom = 1;
var maxZoom = 19;
var emptyTile = "__emptyTile__";
var minLatitude = -85;
var maxLatitude = 85;
var minLongitude = -180;
var maxLongitude = 180;
var tileSize = 256;
var generations = new Object();

// Z-indexes 
var kbInputZIndex = 0;
var containerZIndex = 0;
var mapZIndex = 1;
var swapZIndex = 1;
var baseZIndex = 2;
var debugZIndex = 3;
var baseZIndex = 11;
var topZIndex = 20;

/**
 * Sets a Cookie with the given name and value.
 *
 * name       Name of the cookie
 * value      Value of the cookie
 * [expires]  Expiration date of the cookie (default: end of current session)
 * [path]     Path where the cookie is valid (default: path of calling document)
 * [domain]   Domain where the cookie is valid
 *              (default: domain of calling document)
 * [secure]   Boolean value indicating if the cookie transmission requires a
 *              secure transmission
 */
function SetCookie(name, value, expires, path, domain, secure)
{
    document.cookie= name + "=" + window.escape(value) +
        ((expires) ? "; expires=" + expires.toGMTString() : "") +
        ((path) ? "; path=" + path : "") +
        ((domain) ? "; domain=" + domain : "") +
        ((secure) ? "; secure" : "");
}

/**
 * Gets the value of the specified cookie.
 *
 * name  Name of the desired cookie.
 *
 * Returns a string containing value of specified cookie,
 *   or null if cookie does not exist.
 */
function GetCookie(name)
{
    var dc = document.cookie;
    var prefix = name + "=";
    var begin = dc.indexOf("; " + prefix);
    if (begin == -1)
    {
        begin = dc.indexOf(prefix);
        if (begin != 0) return null;
    }
    else
    {
        begin += 2;
    }
    var end = document.cookie.indexOf(";", begin);
    if (end == -1)
    {
        end = dc.length;
    }
    return window.unescape(dc.substring(begin + prefix.length, end));
}

/**
 * Deletes the specified cookie.
 *
 * name      name of the cookie
 * [path]    path of the cookie (must be same as path used to create cookie)
 * [domain]  domain of the cookie (must be same as domain used to create cookie)
 */
function DeleteCookie(name, path, domain)
{
    if (GetCookie(name))
    {
        document.cookie = name + "=" + 
            ((path) ? "; path=" + path : "") +
            ((domain) ? "; domain=" + domain : "") +
            "; expires=Thu, 01-Jan-70 00:00:01 GMT";
    }
}

















function OutputEncoder_EncodeHtml( strInput )
{
	var c;
	var EncodeHtml = '';
	
	if (strInput == null)
	{
		return '';
	}
	
	for(var cnt = 0; cnt < strInput.length; cnt++)
	{
		c = strInput.charCodeAt(cnt);
		
		if (( ( c > 96 ) && ( c < 123 ) ) ||
			( ( c > 64 ) && ( c < 91 ) ) ||
			( c == 32 ) ||
			( ( c > 47 ) && ( c < 58 ) ) ||
			( c == 46 ) ||
			( c == 44 ) ||
			( c == 45 ) ||
			( c == 95 ))
		{
			EncodeHtml = EncodeHtml + String.fromCharCode(c);
		}
		else
		{
			EncodeHtml = EncodeHtml + '&#' + c + ';';
		}
	}
	
	return EncodeHtml;
}

function OutputEncoder_EncodeHtmlAttribute( strInput )
{
	var c;
	var EncodeHtmlAttribute = '';
	
	if (strInput == null)
	{
		return '';
	}
	
	for(var cnt = 0; cnt < strInput.length; cnt++)
	{
		c = strInput.charCodeAt(cnt);

		if (( ( c > 96 ) && ( c < 123 ) ) ||
			( ( c > 64 ) && ( c < 91 ) ) ||
			( ( c > 47 ) && ( c < 58 ) ) ||
			( c == 46 ) ||
			( c == 44 ) ||
			( c == 45 ) ||
			( c == 95 ))
		{
			EncodeHtmlAttribute = EncodeHtmlAttribute + String.fromCharCode(c);
		}
		else
		{
			EncodeHtmlAttribute = EncodeHtmlAttribute + '&#' + c + ';';
		}
	}
	
	return EncodeHtmlAttribute;
}

function OutputEncoder_EncodeXml( strInput )
{

	return OutputEncoder_EncodeHtml( strInput );
}

function OutputEncoder_EncodeXmlAttribute( strInput )
{

	return OutputEncoder_EncodeHtmlAttribute( strInput );
}
	
function OutputEncoder_EncodeJs( strInput )
{
	var c;
	var EncodeJs = '';
	
	if (strInput == null)
	{
		return '';
	}
	
	for(var cnt = 0; cnt < strInput.length; cnt++)
	{
		c = strInput.charCodeAt(cnt);

		if (( ( c > 96 ) && ( c < 123 ) ) ||
			( ( c > 64 ) && ( c < 91 ) ) ||
			( c == 32 ) ||
			( ( c > 47 ) && ( c < 58 ) ) ||
			( c == 46 ) ||
			( c == 44 ) ||
			( c == 45 ) ||
			( c == 95 ))
		{
			EncodeJs = EncodeJs + String.fromCharCode(c);
		}
		else if ( c > 127 )
		{
			EncodeJs = EncodeJs + '\\u' + OutputEncoder_TwoByteHex(c);
		}
		else
		{
			EncodeJs = EncodeJs + '\\x' + OutputEncoder_SingleByteHex(c);
		}
	}
	
	return '\'' + EncodeJs + '\'';
}

function OutputEncoder_EncodeVbs( strInput )
{
	var c;
	var EncodeVbs = '';
	var bInQuotes = false;
	
	if (strInput == null)
	{
		return '';
	}
	
	for(var cnt = 0; cnt < strInput.length; cnt++)
	{
		c = strInput.charCodeAt(cnt);

		if (( ( c > 96 ) && ( c < 123 ) ) ||
			( ( c > 64 ) && ( c < 91 ) ) ||
			( c == 32 ) ||
			( ( c > 47 ) && ( c < 58 ) ) ||
			( c == 46 ) ||
			( c == 44 ) ||
			( c == 45 ) ||
			( c == 95 ))
		{

			if ( !bInQuotes )
			{
				EncodeVbs = EncodeVbs + '&\"';
				bInQuotes = true;
			}
			
			EncodeVbs = EncodeVbs + String.fromCharCode(c);
		}
		else
		{

			if ( bInQuotes )
			{
				EncodeVbs = EncodeVbs + '\"';
				bInQuotes = false;
			}
			
			EncodeVbs = EncodeVbs + '&chrw(' + c + ')';
		}
	}

	if ( EncodeVbs.charAt(0) == '&' )
	{

		EncodeVbs = EncodeVbs.substring(1);
	}
	
	if ( EncodeVbs.length == 0 )
	{

		EncodeVbs = '\"\"';
	}
	
	if ( bInQuotes )
	{

		EncodeVbs = EncodeVbs + '\"';
	}
	
	return EncodeVbs;
}

function OutputEncoder_AsUrl( strInput )
{
	if (strInput == null)
	{
		return '';
	}
	
	if( strInput.search(/^(?:http|https|ftp):\/\/[a-zA-Z0-9\.\-]+(?:\:\d{1,5})?(?:[A-Za-z0-9\.\;\:\@\&\=\+\$\,\?\/]|%u[0-9A-Fa-f]{4}|%[0-9A-Fa-f]{2})*$/i) )
	{
		throw ("Unsanitized value passed to AsUrl");
	}
	
	return strInput;
}


function OutputEncoder_QualifyUrl( strInput )
{
	if (strInput == null)
	{
		return '';
	}
	
	if ( strInput.search(/^(?:http|https|ftp):\/\//i) )
	{
		if (document.location.protocol == 'HTTPS' )
		{
			return "https://" + document.location.hostname + OutputEncoder_QualifyUrl_MakePath(strInput);
		}
		else
		{
			return "http://" + document.location.hostname + OutputEncoder_QualifyUrl_MakePath(strInput);
		}
	}
	else
	{

		return strInput;
	}
}

function OutputEncoder_QualifyUrl_MakePath( strInput )
{
	if (strInput == null)
	{
		return '';
	}
	
	if( ! strInput.search(/^[\/\\]/) )
	{
		return strInput;
	}
	

	var re = /^(\/(?:.*\/|))(?:[^\/\\]*\.\w+|\w*)$/;
	if( ! document.location.pathname.search(re) )
	{
		var path = re.exec(document.location.pathname);
		return path[1] + strInput;
	}
	
	return '/' + strInput;
}

function OutputEncoder_AsNumeric( strInput )
{
	if (strInput == null)
	{
		return '';
	}
	
	if( isNaN(parseFloat(strInput)) )
	{
		// Error out!
		throw "IOSec.AsNumeric(): Error input ["+strInput+"] not a valid number.";
	}
	
	return strInput;
}

//
// safely truncate an url (meaning: don't leave any dangling encoded characters)
// also, append optional notification when the string is truncated
function OutputEncode_TruncateUrlSafe( strUrl, intMaxLength, strNotification )
{
	if ( strUrl.length <= intMaxLength )
	{
		return strUrl;
	}
	
	var strEncNotification = "";
	if ( strNotification && strNotification.length > 0 )
	{
		strEncNotification = OutputEncoder_EncodeUrl ( strNotification );
		intMaxLength -= strEncNotification.length;
	}
	
	//
	// truncate the url to the max length
	var strUrl = strUrl.substring ( 0, intMaxLength );
	
	//
	// search at most 5 characters back for a '%'
	for (var ii=1; ii < 6; ii++)
	{
		if ( strUrl.charAt ( intMaxLength - ii ) == "%" )
		{
			//
			// cut off the dangling encoded character
			strUrl = strUrl.substring ( 0, intMaxLength - ii );
			break;
		}
	}
	
	return strUrl + strEncNotification;
}
	
//
// url encodes a string with a specified set of delimiters and '%'
// if ( strDelim == null ) the original string is returned unmodified
// otherwise, the string is returned with the correct escaping
// note that "" is a valid delim and will return the string with '%' escaped
function OutputEncode_EncodeUrlDelims( strDelim, strInput )
{
	
	if ( !strDelim )
	{
		return strInput;
	}

	var c; // char in string
	var d; // delim
	var EncodeUrl = '';
	
	for(var cnt = 0; cnt < strInput.length; cnt++)
	{
		c = strInput.charCodeAt(cnt);
		//
		// escape % and move to the next character
		if ( 37 == c ) // 37 == '%'
		{
			EncodeUrl = EncodeUrl + '%' + OutputEncoder_SingleByteHex(c);
			continue;
		}
		
		//
		// escape each delimiter
		
		
		var encodedCharacter = strInput.charAt(cnt);
		for(var dcnt = 0; dcnt < strDelim.length; dcnt++)
		{
			d = strDelim.charCodeAt(dcnt);
			
			if ( d == c )
			{
				if ( c > 127 )
				{
					encodedCharacter = '%u' + OutputEncoder_TwoByteHex(c);
				}
				else
				{
					encodedCharacter = '%' + OutputEncoder_SingleByteHex(c);
				}
				//
				// exit the delim loop
				break; // no more encoding for this char
			}
		} // end for (delims)
		
		EncodeUrl += encodedCharacter;
	}
	
	return EncodeUrl;
}
function OutputEncoder_EncodeUrl( strInput )
{
	if (strInput == null)
	{
		return '';
	}
	
	var c;
	var EncodeUrl = '';
	
	for(var cnt = 0; cnt < strInput.length; cnt++)
	{
		c = strInput.charCodeAt(cnt);

		if (( ( c > 96 ) && ( c < 123 ) ) ||
			( ( c > 64 ) && ( c < 91 ) )  ||
			( ( c > 47 ) && ( c < 58 ) ) ||
			( c == 46 ) ||
			( c == 45 ) ||
			( c == 95 ))
		{
			EncodeUrl = EncodeUrl + String.fromCharCode(c);
		}
		else if ( c > 127 )
		{
			EncodeUrl = EncodeUrl + '%u' + OutputEncoder_TwoByteHex(c);
		}
		else
		{
			EncodeUrl = EncodeUrl + '%' + OutputEncoder_SingleByteHex(c);
		}
	}
	
	return EncodeUrl;
}
	
function OutputEncoder_SingleByteHex( charC )
{
	if (charC == null)
	{
		return '';
	}
	
	var SingleByteHex = charC.toString(16);

	for ( var cnt = SingleByteHex.length; cnt < 2; cnt++ )
	{
		SingleByteHex = "0" + SingleByteHex;
	}
	
	return SingleByteHex;
}

function OutputEncoder_TwoByteHex( charC )
{
	if (charC == null)
	{
		return '';
	}
	
	var TwoByteHex = charC.toString(16);

	for( var cnt = TwoByteHex.length; cnt < 4; cnt++ )
	{
		TwoByteHex = "0" + TwoByteHex;
	}
	
	return TwoByteHex;
}

function OutputEncoder()
{
	this.EncodeHtml = OutputEncoder_EncodeHtml;
	this.EncodeHtmlAttribute = OutputEncoder_EncodeHtmlAttribute;
	this.EncodeXml = OutputEncoder_EncodeXml;
	this.EncodeXmlAttribute = OutputEncoder_EncodeXmlAttribute;
	this.EncodeJs = OutputEncoder_EncodeJs;
	this.EncodeVbs = OutputEncoder_EncodeVbs;
	this.AsNumeric = OutputEncoder_AsNumeric;
	this.EncodeUrl = OutputEncoder_EncodeUrl;
	this.EncodeUrlDelims = OutputEncode_EncodeUrlDelims;
	this.TruncateUrlSafe = OutputEncode_TruncateUrlSafe;
	this.SingleByteHex = OutputEncoder_SingleByteHex;
	this.TwoByteHex = OutputEncoder_TwoByteHex;
	this.AsUrl = OutputEncoder_AsUrl;
	this.QualifyUrl = OutputEncoder_QualifyUrl;
}

var IOSec = new OutputEncoder();



//------------------------------------------------------------------------------
// Analytics.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, Cthota
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Empty constructor, needed to use the class name.
function VE_Analytics()
{
	
}


function VE_Range(min,max)
{
	this.min = min;
	this.max = max;
}

VE_Range.prototype.IsInRange=function(val)
{
	return val >= this.min && 
	       val <= this.max;
	       
};

VE_Range.prototype.toString=function()
{
	return this.min+"-"+this.max;
};
                                        
VE_Analytics.distanceBuckets = new Array(new VE_Range(0,10),
									   new VE_Range(11,25),
									   new VE_Range(26,100),
									   new VE_Range(101,200),
									   new VE_Range(201,500),
									   new VE_Range(501,1000));
// Whether or not analytics is enabled.
VE_Analytics.analyticsEnabled = true;

// Logs the user opening the help from the main header.
VE_Analytics.LogHelp=function()
{
	VE_Analytics.Log("VE | Help Pane","Help");
};
// Logs the user opening the about page from the main header.
VE_Analytics.LogAbout=function()
{
	VE_Analytics.Log("VE | About Pane","About");
};

// Logs the user printing the details from the Details page
VE_Analytics.LogPrintDetailsPage=function()
{
	VE_Analytics.Log("VE | Details Page","Print");
};

// Logs the user getting directions(to/from) from the Details page
VE_Analytics.LogGetDirectionsDetailsPage=function()
{
	VE_Analytics.Log("VE | Details Page","Get Directions");
};

// Logs the user getting more info from the Details page
VE_Analytics.LogGetMoreInfoDetailsPage=function()
{
	VE_Analytics.Log("VE | Details Page","MSN Search");
};

// Logs the user opening the locate me page from the main header
VE_Analytics.LogLocate=function()
{
	VE_Analytics.Log("VE | Locate Me","Locate Me");
};

VE_Analytics.LogResponseTimes=function()
{
	//Note[a-pratin]: We assign all the calculation to tempVar and then apply toFixed() method because JSRewrite tool 
	//				  used for compression in the release build breaks the javascript format in this function if not applied.	
	
	var tempVar = map.GetFailureRate()*100;
	s.prop33 = tempVar.toFixed(1);
	
	tempVar = map.GetResponseRangeCounts()[0]*100;
	s.prop34 = tempVar.toFixed(1);//taget response time	
	
	tempVar = map.GetResponseRangeCounts()[2]*100;
	s.prop35 = tempVar.toFixed(1);//outlies response time
	
	VE_Analytics.Log("VE | Response Times");
	map.ResetResponseRangeCounts();
};
// Logs the user zooming the map in or out
VE_Analytics.LogZoom=function()
{	
	VE_Analytics.Log(map.GetMapStyle() == Msn.VE.MapStyle.Oblique ? "VE | Oblique Imagery" : "VE | Home Page","Zoom","Mouse/Game Control/Keyboard");
};

VE_Analytics.LogPan=function()
{
	VE_Analytics.Log(map.GetMapStyle() == Msn.VE.MapStyle.Oblique ? "VE | Oblique Imagery" : "VE | Home Page","Pan","Mouse/Game Control/Keyboard");
};

VE_Analytics.LogFailedSearch=function()
{
	s.prop11 = "No Search Results";
	VE_Analytics.Log("VE | Exception","Search");
};

VE_Analytics.LogJSWatson=function(errorMessage)
{
	if(errorMessage != null && errorMessage != "undefined" && errorMessage.length > 0)
	{
		s.prop11 = errorMessage;
		VE_Analytics.Log("VE | Exception", "JSWatson");
	}
};


VE_Analytics.LogScrachPadItems=function()
{
	s.prop12 = VE_Scratchpad.highWaterCount;
	VE_Analytics.Log("VE | Scratch Pad","Exit");
};

VE_Analytics.LogAds=function(what, eventName, pagename, numberOfAds, indexOfAdClicked, adsProvider)
{
	s.events = eventName;
	
	if(what == null || what == "undefined")
		s.eVar8 = document.getElementById("what") ? (document.getElementById("what").value == L_MainWhatHelp_Text ? "" : document.getElementById("what").value) : "";
	else
		s.eVar8 = what;
		
	s.eVar9 = document.getElementById("where") ? (document.getElementById("where").value == L_SearchUseCurrentViewText_Text ? VE_Analytics.FormatLatLong(map.GetCenterLatitude(),map.GetCenterLongitude()) : document.getElementById("where").value) : "";
	
	if(eventName == "Event6")
	{
		s.eVar11 = indexOfAdClicked;
	}
	else
	{
		s.eVar10 = numberOfAds;		
	}
	
	if(adsProvider != null && adsProvider != "undefined")
	{
		s.eVar12 = adsProvider;		
	}
	else
	{
		s.eVar12 = "";		
	}
	
	//alert(s.events + ":" + s.eVar8 + ":" + s.eVar9 + ":" + s.eVar11 + ":" + s.eVar10 + ":" + s.eVar12);
	
	VE_Analytics.Log("VE | " + pagename,null);
};

//Set campaign id
VE_Analytics.SetCampaignId=function(cid)
{
	if(cid != null && cid != "" && cid != "undefined")
	{
		if(s)
		{
			s.campaign = cid;
			VE_Analytics.Log("VE | Home Page","Campaign Page View");
		}
	}
};

VE_Analytics.LogClick2Call=function(source)
{
	//Source is not supported yet. So it always logs 
	//Search Pane ERO as default
	//Ideally we should be populating s.prop37 
	//Since we dont have source at this point from MPC
	//We will pass default.
	if(source != null && source != "undefined")
	{
		if(source == "1")
			VE_Analytics.Log("VE | Search Pane ERO", "C2C call Entry Point");			
		else if(source == "2")		
			VE_Analytics.Log("VE | Map ERO", "C2C call Entry Point");			
		else if(source == "3")		
			VE_Analytics.Log("VE | Details Page", "C2C call Entry Point");			
		else
			VE_Analytics.Log("VE | Click-2-Call", "C2C call Entry Point");					
	}
	else
	{
		VE_Analytics.Log("VE | Click-2-Call", "C2C call entry point");		
	}
}

VE_Analytics.LogAPI=function(pageName,NavAction)
{
	//currently turn off logging for the API - see Bug 4794
	return; 
	
	if ( window.s == 'undefined' || window.s == null )
		return;
		
	// Only log if analytics is enabled.
	if (!VE_Analytics.analyticsEnabled)
	{
		return;
	}
	
	s.pageName = pageName;		
	s.prop6 = NavAction ? NavAction : "";	
		
	var elm = document.getElementById("logging");
	if(elm)
	{
		elm.innerHTML = s.t();
	}
	VE_Analytics.ResetLogProps();
}

VE_Analytics.Log=function(pageName,NavAction,NavControl,routeLengthObj)
{
	if ( window.s == 'undefined' || window.s == null )
		return;
		
	// Only log if analytics is enabled.
	if (!VE_Analytics.analyticsEnabled)
	{
		return;
	}
	
	s.pageName = pageName;
	s.prop3 = window["map"] ? map.GetMapStyle() : "";
	s.prop4 = window["map"] ? map.GetZoomLevel() : "" ;
	s.prop5 = window["map"] ? VE_Analytics.FormatLatLong(map.GetCenterLatitude(),map.GetCenterLongitude()) : "";
	s.prop6 = NavAction ? NavAction : "";
	s.prop7 = NavControl ? NavControl : "";
	s.prop8 = document.getElementById("what") ? (document.getElementById("what").value == L_MainWhatHelp_Text ? "" : document.getElementById("what").value) : "";
	s.prop9 = document.getElementById("where") ? (document.getElementById("where").value == L_SearchUseCurrentViewText_Text ? "" : document.getElementById("where").value) : "";
	s.prop36 = ( window.usertype == undefined ) ? 1 : usertype; 
	
	if(routeLengthObj) /* routing information is available */
	{
		
		s.prop10 = VE_Analytics.ConvertDistanceToBucket(routeLengthObj);	
		
		s.prop32 = 	routeLengthObj.numberOfWaypoints;
		
	}
	else 
	{
		s.prop10 = "";
	}
	
	var elm = document.getElementById("logging");
	if(elm)
	{
		elm.innerHTML = s.t();
	}
	VE_Analytics.ResetLogProps();
};
/* For Ominiture logging region codes needs to be formatted as follows
 * latitude (1 decimal place)+","+longitude (0 decimal places or an integer)

 */
VE_Analytics.FormatLatLong=function(latitude,longitude)
{
	if(!latitude || !longitude)
	{
		if(state && state.GetLatitude() && state.GetLongitude()) 
		{	
			return state.GetLatitude().toFixed(1)+","+Math.round(state.GetLongitude());
		}
		return "0.0,0";
	}
	return latitude.toFixed(1)+","+Math.round(longitude);
};

VE_Analytics.ConvertDistanceToBucket=function(routeLengthObj)
{
	var distance  = routeLengthObj.distance;
	
	if(!distance)
	{
		return "";
	}
    
	if(routeLengthObj.distanceUnit && 
	   routeLengthObj.distanceUnit.indexOf("mi") != -1)
	{ /* convert miles to kilometers first */
		distance = Math.round(distance*1.6093);
	}
	//find the range bucket
	
	for(var i =0;i < VE_Analytics.distanceBuckets.length; i++)
	{
		if(VE_Analytics.distanceBuckets[i].IsInRange(distance))
		{
			return VE_Analytics.distanceBuckets[i].toString();
		}
	}
	
	return "1001 and Above";
};

VE_Analytics.ResetLogProps=function()
{
	s.prop11 = "";
	s.prop12 = "";
	s.prop32 = "";
	s.prop33 = "";
	s.prop34 = "";
	s.prop35 = "";
	
	//Clear all events stuff
	s.events = "";
	s.eVar8 = "";
	s.eVar9 = "";
	s.eVar10 = "";
	s.eVar11 = "";		
	s.eVar12 = "";		
	
	//Clear campaign
	s.campaign = "";	

};
//------------------------------------------------------------------------------
//	Marketization.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-pratin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

//Marketization Class
RegisterNamespaces("Msn.VE");

Msn.VE.Marketization = new function()
{
	this.IsEnabled = function ( featureValue )
	{		
		if ( featureValue == undefined )
		{
			throw new VEException( "Msn.VE.Marketization.IsEnabled","err_invalidfeature","Specified feature is invalid.");
		}		
		return( featureValue );		
	}
}

//==================================================================================================
//Exception class
//==================================================================================================
function VEException(source, name, message){
this.source=source; 
this.name=name;
this.message=message;
}
VEException.prototype.Name=this.name;
VEException.prototype.Source=this.source;
VEException.prototype.Message=this.message;
//End Exception class



var STEP_MAP_WIDTH = 180;
var STEP_MAP_HEIGHT = 135;

var MAX_STEPS_START_END = 5;
var MIN_STEPS_START_END = 2;
var MAX_COMBINE_STEPS = 2;

var printDirectionsManager = null;
var VE_ContextMenu = null; // This was added to fix a undefined reference bug?!

var preSetPrintOption = null;
var PrintMapsAndDirections = 1;
var PrintDirectionsOnly = 2;
var PrintMapsOnly = 3
var directPrintOption = false;
var setTimerOption = false;
var printDelay = 500;
var usertype = 1;

// UI for PrintableMap.aspx
function LoadUI()
{
	// Determine which map elements exist.
	var routeExists = ((window.opener && window.opener.VE_Directions.displayedRoute) || (window.parent.map && window.parent.VE_Directions.displayedRoute));
	var scratchPadExists = ((window.opener && window.opener.scratchPad.isVisible() && window.opener.scratchPad.getItems().getCount() > 0) || (window.parent.map && window.parent.scratchPad.isVisible() && window.parent.scratchPad.getItems().getCount() > 0))
	var collectionExists = ((window.opener && window.opener.VE_CollectionsManager && window.opener.VE_CollectionsManager.Viewer && window.opener.VE_CollectionsManager.Viewer.panel && window.opener.VE_CollectionsManager.Viewer.panel.el.parentNode) || (window.parent.map && window.parent.VE_CollectionsManager && window.parent.VE_CollectionsManager.Viewer && window.parent.VE_CollectionsManager.Viewer.panel && window.parent.VE_CollectionsManager.Viewer.panel.el.parentNode));
	var searchCount = GetSearchCount(window.opener ? window.opener.VE_SearchManager.searches : window.parent.VE_SearchManager.searches);
	
	// set the Window Title
	window.document.title = L_PrintableDirectionsManagerWindowTitle_Text.replace(/%1/g,Msn.VE.Features.ProductName); 
	// set meta tag title content
	document.getElementById("msve_description").content = Msn.VE.Features.ProductName;
	// set meta tag description content
	document.getElementById("msve_description").content = L_PrintableDirectionsManagerMetaDescription_Text.replace(/%1/g,Msn.VE.Features.ProductName);
	
	
 	//logo
	var logoElement = "<div id=\"msnVEHeader\"><img src=\"" + img_LogoMastHead + "\" border=\"0\"/></div>";

	var instructionsContainerElement = "<div id=\"instructionsContainer\">" +	
							"<h1>" + L_PrintableDirectionsManagerPrintOptions_Text + "</h1>" +
							"</div>";
			  
	var presetContainerElement = "<div id=\"presetContainer\" class=\"yellowRectangle\"><table>" +
								"<tr><td><b>" + L_PrintableDirectionsManagerPresetPrintOptions_Text + ":</b></td><td></td></tr>" +
								"<tr><td><a href=\"javascript:void(0)\" id=\"everythingOnPresetLink\">" + L_PrintableDirectionsManagerPrintMapAndDirections_Text + "</a><br/>" +
								"<a href=\"javascript:void(0)\" id=\"overmapOnlyPresetLink\">" + L_PrintableDirectionsManagerPrintMapOnly_Text + "</a><br/>" +
								"<a href=\"javascript:void(0)\" id=\"instructionsOnlyPresetLink\">" + L_PrintableDirectionsManagerPrintDirectionsOnly_Text + "</a></td>" +
								"<td class=\"printCancelCell\"><input type=\"button\" value=\"" + L_PrintableDirectionsManagerPrint_Text + "\" id=\"topPrint\"/>" +
								" <input type=\"button\" value=\"" + L_PrintableDirectionsManagerCancel_Text + "\" id=\"topCancel\"/></td></tr></table></div>";

	var textPrintTheRouteMap = L_PrintableDirectionsManagerPrintRouteMap_Text;

	// We do some craziness here because we need to eliminate the first column is only useful for routes
	var column1Header = "";
	var column1RouteStart = "";
	var column1RouteEnd = "";
	var column1WholeRoute = "";
	if (routeExists)
	{
		column1Header = "<td>" + L_PrintableDirectionsManagerMapCoverage_Text + "</td>";
		column1RouteStart = "<tr><td><a href=\"javascript:void(0)\" id=\"showStartLink\">" + L_PrintableDirectionsManagerStart_Text + "</a></td>";
		column1RouteEnd = "<tr><td><a href=\"javascript:void(0)\" id=\"showEndLink\">" + L_PrintableDirectionsManagerEnd_Text + "</a></td>";
		column1WholeRoute = "<tr><td><a href=\"javascript:void(0)\" id=\"showEntireLink\">" + L_PrintableDirectionsManagerEntireRoute_Text + "</a></td>";
	}
	var overviewMapSettingsContainerElement = "<div id=\"overviewMapSettingsContainer\" class=\"yellowRectangle\">" +
				"<table><tr><td><input type=\"checkbox\" checked=\"true\" id=\"toggleOverviewMapBox\"/>" + textPrintTheRouteMap + "</td>" +
				"</tr><tr><td><table id=\"overviewMapControlTable\"><tr>" + 
				column1Header + 
				"<td>" + L_PrintableDirectionsManagerMapSize_Text + "</td>" +
				"<td>" + L_PrintableDirectionsManagerMapStyle_Text + "</td></tr>" +
				column1RouteStart +
				"<td><input type=\"radio\" name=\"size\" value=\"small\" id=\"smallMapSizeLink\">" + L_PrintableDirectionsManagerSmall_Text + "</input></td>" +
				"<td><input type=\"radio\" name=\"style\" value=\"road\" id=\"roadStyleLink\" checked=\"true\"/>" + L_PrintableDirectionsManagerRoad_Text + "</td></tr>" +
				column1RouteEnd +
				"<td><input type=\"radio\" name=\"size\" value=\"medium\" id=\"mediumMapSizeLink\" checked=\"true\">" + L_PrintableDirectionsManagerMedium_Text + "</input></td>" +
				"<td><input type=\"radio\" name=\"style\" value=\"arial\" id=\"arialStyleLink\"/>" + L_PrintableDirectionsManagerAerial_Text + "</td></tr>" +
				column1WholeRoute +
				"<td><input type=\"radio\" name=\"size\" value=\"large\" id=\"largeMapSizeLink\"/>" + L_PrintableDirectionsManagerLarge_Text + "</td>" +
				"<td><div id=\"showLabelsContainer\"><input type=\"checkbox\" id=\"arialLabelsToggle\" checked=\"true\" NAME=\"arialLabelsToggle\"/> " + L_PrintableDirectionsManagerShowLabels_Text + "</div></td></tr>" +
				"</table></td></tr></table></div>";

	var overviewMapContainerElement = "<div id=\"overviewMapContainer\"></div>";
	
	var directionsOverviewElement = "<div id=\"summaryControlsContainer\" class=\"yellowRectangle\">" +
									"<table><tr><td><input type=\"checkbox\" checked=\"true\" id=\"toggleSummaryBox\"/>" + L_PrintableDirectionsManagerPrintRouteSummary_Text + "</td></tr>" +
									"</table></div><div id=\"summaryContainer\">" +
									"<table id=\"summaryTable\">" +
									"<tr><td><strong class=\"greenText\">" + L_PrintableDirectionsManagerStart_Text + ": </strong><span id=\"summaryStart\"></span></td>" +
									"<td><strong>" + L_PrintableDirectionsManagerDistance_Text + ":</strong> <span id=\"summaryDistance\"></span></td></tr>" +
									"<tr><td><strong class=\"redText\">" + L_PrintableDirectionsManagerEnd_Text + ": </strong><span id=\"summaryEnd\"></span></td>" +
									"<td><strong>" + L_PrintableDirectionsManagerTime_Text + ":</strong> <span id=\"summaryTime\"></span></td></tr></table></div>";
									  
	var directionControlContainerElement = "<div id=\"directionControlContainer\" class=\"yellowRectangle\">" +
										"<table><tr><td><input type=\"checkbox\" id=\"displayDirectionsCheckbox\" checked=\"true\"/>" + L_PrintableDirectionsManagerPrintDirections_Text + "<br/><br/></td>" +
										"</tr><tr><td><strong>" + L_PrintableDirectionsManagerShowInstructions_Text + "</strong></td>" +
										"</tr><tr><td><input type=\"radio\" id=\"directionsAll\" name=\"directions\" value=\"all\" checked=\"true\"/>" + L_PrintableDirectionsManagerAll_Text +"</td>" +
										"</tr><tr><td><input type=\"radio\" id=\"directionsStart\" name=\"directions\" value=\"start\"/>"+ L_PrintableDirectionsManagerStartOnly_Text + "</td></tr>" +
										"<tr><td><input type=\"radio\" id=\"directionsEnd\" name=\"directions\" value=\"end\"/>" + L_PrintableDirectionsManagerEndOnly_Text + "</td></tr>" +
										"<tr><td><p>" + L_PrintableDirectionsManagerDirectionControl_Text + "</p></td></tr></table></div>";

	var directionsViewContainerElement = "<div id=\"directionsViewContainer\"></div>";

	var scratchPadControlContainerElement = "<div id=\"scratchPadContainer\" class=\"yellowRectangle\">" +
											"<table><tr><td><input type=\"checkbox\" id=\"displayScratchPadCheckbox\" checked=\"true\"/>" + L_PrintableDirectionsManagerPrintTheScratchPad_Text + "</td></tr>" +
											"</table></div>";

	var scratchPadViewContainerElement = "<div id=\"scratchPadViewContainer\"></div>";

	if (collectionExists)
	{
		var collectionTitle = (window.opener ? window.opener.VE_CollectionsManager.Viewer.title : window.parent.VE_CollectionsManager.Viewer.title);
		var collectionControlContainerElement = "<div id=\"collectionContainer\" class=\"yellowRectangle\">" +
												"<table><tr><td><input type=\"checkbox\" id=\"displayCollectionCheckbox\" checked=\"true\"/>" + L_PrintableDirectionsManagerPrintCollection_Text + " \"" + collectionTitle + "\"</td></tr>" +
												"</table></div>";
	}
	
	var collectionViewContainerElement = "<div id=\"collectionViewContainer\"></div>";

	var searchControlContainerElement = "<div id=\"searchContainer\" class=\"yellowRectangle\">" +
										"<table><tr><td><input type=\"checkbox\" id=\"displaySearchCheckbox\" checked=\"true\"/>" + L_PrintableDirectionsManagerPrintSearchResults_Text + "</td></tr>" +
										"</table></div>";

	var searchViewContainerElement = "<div id=\"searchViewContainer\"></div>";
	
	var notesControlContainerElement = "<div id=\"notesControlContainer\" class=\"yellowRectangle\"><input type=\"checkbox\" checked=\"true\" id=\"toggleNotesBox\"/>" + L_PrintableDirectionsManagerPrintMyNotes_Text + "</div>";

	var notesTableContainerElement = "<table id=\"notesTableContainer\"><tr>" +
									"<td><textarea id=\"notesText\">[" + L_PrintableDirectionsManagerTypeYourNotes_Text + "]</textarea><div id=\"printableNotes\"></div></td>" +
									"</tr></table>";
									 
	var printButtonsTableElement = "<table id=\"printButtonsTable\"><tr>" +
								"<td><input type=\"button\" value=\"" + L_PrintableDirectionsManagerPrint_Text + "\" id=\"bottomPrint\"/> <input type=\"button\" value=\"" + L_PrintableDirectionsManagerCancel_Text + "\" id=\"bottomCancel\"/></td>" +
								"</tr></table>";

	//add element to the main body	
	document.body.innerHTML =	logoElement +
								instructionsContainerElement +
								presetContainerElement +
								overviewMapSettingsContainerElement +
								overviewMapContainerElement +
								(routeExists ? directionsOverviewElement + directionControlContainerElement + directionsViewContainerElement : "") +
								(scratchPadExists ? scratchPadControlContainerElement + scratchPadViewContainerElement : "") +
								(collectionExists ? collectionControlContainerElement + collectionViewContainerElement : "") +
								(searchCount > 0 ? searchControlContainerElement + searchViewContainerElement : "") +
								notesControlContainerElement + 
								notesTableContainerElement +
								printButtonsTableElement;
	

	PrintableDirectionsMain();	
}

/**
  * Global: GetSearchCount
  * takes the searches array
  * and determines real length
  * 
  */
function GetSearchCount(searches)
{
	if (!searches || searches.length == 0)
		return 0;

	for(var i=0; i<searches.length; ++i)
	{
		if (searches[i].results.length > 0)
		{
			return searches.length;
		}
	}
}

/**
  * Class: VE_CombinedInstruction
  * wrapper class around Array to manage combined instructions
  * 
  */
function VE_CombinedInstruction() 
{
	var instructions = new Array();
	
	function AddInstruction(instruction)
	{
		instructions.push(instruction);
	}
	function GetInstructions()
	{
		return instructions;
	}
	this.AddInstruction = AddInstruction;
	this.GetInstructions = GetInstructions;
}

/**
  * Class: VE_StepRowView
  * This view class is responsible for rendering combined instruction
  * rows and handling showing and hiding of individual rows.
  */
function VE_StepRowView(mapParams,aMapRoute,combinedInstructions,directionTableBody, displayTurnByTurn)
{
	var eventMap = new Array();
	var enableDispatchEvents = false;
	var mapControl = null;
	var mapContainerDiv = null;
	var defaultMapParams = mapParams;
	var mapRoute = aMapRoute;
	var instructionRows = new Array();
	var mapControlInput = null;
	var visible = true;
	
	//
	// Creates a tr DOM element, map control and sets
	// up event handling for display map control
	//	
	function CreateRowForInstructions()
	{
		var instructions = combinedInstructions.GetInstructions();
						
		var len = instructions.length;
		for(var stepsIt = 0; stepsIt < len ; ++stepsIt)
		{
			// Create the Instruction Row
			var instructionRow = document.createElement("tr");
			
			directionTableBody.appendChild(instructionRow);
			instructionRows.push(instructionRow);

			// Create the Position Cell.			
			var instructionPositionCell = document.createElement("td");
			instructionPositionCell.style.verticalAlign = "top";
			instructionPositionCell.style.width = "45px";
			instructionPositionCell.style.textAlign = "left";
			
			var positionHtml = "<strong";
			if(instructions[stepsIt].position == "Start")
			{
				positionHtml += " class=\"greenText\"";
			}
			else if(instructions[stepsIt].position == "End")
			{
				positionHtml += " class=\"redText\"";
			}
			positionHtml += ">" + instructions[stepsIt].position + "</strong>:";
			instructionPositionCell.innerHTML = positionHtml;
			instructionRow.appendChild(instructionPositionCell);
			
			// Create the Instruction Text Cell
			var instructionTextCell = document.createElement("td");
			instructionTextCell.style.verticalAlign = "top";
			instructionTextCell.style.textAlign = "left";
			
			instructionTextCell.innerHTML = IOSec.EncodeHtml(instructions[stepsIt].name);
			instructionRow.appendChild(instructionTextCell);

			if (instructions[stepsIt].distance)
			{
				// Create the Distance Cell if we have a distance
				var instructionDistanceCell = document.createElement("td");
				instructionDistanceCell.style.textAlign = "right";
				instructionDistanceCell.style.verticalAlign = "top";
				instructionDistanceCell.style.width = "60px";
				if (stepsIt == len - 1)
				{
					instructionDistanceCell.className = "finalCombinedStepCell";
				}
				
				instructionDistanceCell.innerHTML = instructions[stepsIt].distance + " " + aMapRoute.distanceUnit;
				instructionRow.appendChild(instructionDistanceCell);
			}
			else
			{
				// Otherwise, have the instruction text cover the distance column as well.
				instructionTextCell.colSpan = 2;
			}
			
			// Add a bottom border if this is the last instruction in the combined instruction
			if (stepsIt == len - 1)
			{
				instructionPositionCell.className = "finalCombinedStepCell";
				instructionTextCell.className = "finalCombinedStepCell";
			}

			// Exit if we have already created the map cell			
			if (stepsIt != 0)
			{
				continue;
			}
			
			// Create the map cell
			var instructionMapCell = document.createElement("td");
			instructionMapCell.className = "stepMapCell secondDirectionColumn";
			instructionMapCell.rowSpan = len;

			mapControlInput = document.createElement("input");
			mapControlInput.setAttribute("type","checkbox");
			mapControlInput.className = "overMapToggleCheckbox";
			mapControlInput.attachEvent("onclick",ToggleMap);
			
			instructionMapCell.appendChild(mapControlInput);
			
			mapContainerDiv = document.createElement("div");
			mapContainerDiv.className = "routeInstructionMapDiv";
			
			instructionMapCell.appendChild(mapContainerDiv);			
			instructionRow.appendChild(instructionMapCell);			
			
			// Create the turn by turn map if requested.
			if (displayTurnByTurn)
			{
				mapControlInput.setAttribute("checked","true");
				CreateMapControl();
			}
			else
			{
				mapControlInput.setAttribute("checked","false");
				HideMap();
			}			
		}
		
		enableDispatchEvents = true;
	}
	
	function CreateMapControl()
	{
		var instructions = combinedInstructions.GetInstructions();
	
		// Set-up the parameters for the initializing the map.
		var params = new Object();	
		params.latitude = instructions[0].latitude;
		params.longitude = instructions[0].longitude;
		params.zoomlevel = defaultMapParams.zoomlevel;
		params.mapstyle  = "r";
		params.fixedView = true;		
		params.showDashboard = false;
		params.disableLogo = true;

		// Create the map control
		mapControl = new Msn.VE.MapControl(mapContainerDiv, params);
		mapControl.Init();

		//if more than 1 instruction then calculate the best viewport 
		//for the combined steps
		var latLongs = new Array();
		
		for(var i = 0;i < instructions.length; ++i)
		{
			latLongs.push(new Msn.VE.LatLong(instructions[i].latitude,instructions[i].longitude));
		}
				
		// Set the view to contain all the instruction steps.		
		mapControl.SetBestMapView(latLongs);
		mapControl.SetZoom(Math.min(16, mapControl.GetZoomLevel()));

		//add a push pin for each instruction
		AddInstructionPushPins();

		// Add the route highlight.
		mapControl.AddLine("veDDHighlight", 
			aMapRoute.latitudes, 
			aMapRoute.longitudes, 
			6, 
			"#11DD11", 
			4, 
			aMapRoute.routeRegionsByZoomLevel,
			aMapRoute.zoomLevelsForGeneralizedLines);
		
		// Show our new map.
		ShowMap();
	}
	
	
	function AddInstructionPushPins()
	{
		var instructions = combinedInstructions.GetInstructions();
		var len = instructions.length;
		
		for(var stepsIt = 0; stepsIt < len ; ++stepsIt)
		{
			//add instruction push pin
			if(instructions[stepsIt].position == "Start")
			{
				mapControl.AddPushpin("step_"+stepsIt,                                     // pushpinID
									instructions[stepsIt].latitude,                               // latitude
									instructions[stepsIt].longitude,                              // longitude
									14,                                     // width
									14,                                     // height
									"VE_Pushpin",                              // className
									"<img src=\"i/pins/mapicon_start.gif\"/>",                                   // innerHTML
									17,											// zIndex
									Msn.VE.PushPinTypes.Direction				// pushpin type
									); 
			}
			else if(instructions[stepsIt].position == "End")
			{
				mapControl.AddPushpin("step_"+stepsIt,                                     // pushpinID
									instructions[stepsIt].latitude,                               // latitude
									instructions[stepsIt].longitude,                              // longitude
									14,                                     // width
									14,                                     // height
									"VE_Pushpin",                              // className
									"<img src=\"i/pins/mapicon_end.gif\"/>",                                   // innerHTML
									17,
									Msn.VE.PushPinTypes.Direction				// pushpin type
									); 
			}
			else
			{
				mapControl.AddPushpin("step_"+stepsIt,                                     // pushpinID
									instructions[stepsIt].latitude,                               // latitude
									instructions[stepsIt].longitude,                              // longitude
									16,                                     // width
									16,                                     // height
									"VE_Pushpin",                              // className
									"<img src=\"i/pins/RedCircle"+instructions[stepsIt].position+".gif\"/>",                                   // innerHTML
									17,
									Msn.VE.PushPinTypes.Default					// pushpin type
									); 
			}
		}
	}

	//
	//
	//
	function GetMapControl()
	{
		return mapControl;
	}
	
	function ShowMap(e)
	{
		mapContainerDiv.style.display = "block";
		mapControlInput.checked = true;
		if (mapControl == null)
		{
			CreateMapControl();
		}
		DispatchEvent("onmaptoggle");
	}
	function HideMap(e)
	{
		mapContainerDiv.style.display = "none";
		mapControlInput.checked = false;
		DispatchEvent("onmaptoggle");
	}
	
	function ToggleMap(e)
	{
		mapContainerDiv.style.display == "block" ? HideMap(): ShowMap();
	}
	
	function Hide()
	{
		visible = false;
		for (var i = 0; i < instructionRows.length; i++)
		{
			instructionRows[i].style.display = "none";
		}
	}
	
	function Show()
	{
		visible = true;
		for (var i = 0; i < instructionRows.length; i++)
		{
			instructionRows[i].style.display = "";
		}
	}
	
	function IsVisible()
	{
		return visible;
	}
	
	function MapVisible()
	{
		return mapControlInput.checked == true;
	}
	
	function GetHeight()
	{
		if (MapVisible())
		{
			return STEP_MAP_HEIGHT + 2; // Seems like we need some buffer to get around breaking issues.
		}
		else
		{
			var height = 0;
			// For some reason, this color change will not actually get reflected on the page.
			for (var i = 0; i < instructionRows.length; i++)
			{
				height += instructionRows[i].offsetHeight;
			}
			return height;
		}
	}
	
	function SetBackgroundColor(color)
	{
		// For some reason, this color change will not actually get reflected on the page.
		for (var i = 0; i < instructionRows.length; i++)
		{
			instructionRows[i].style.backgroundColor = color;
		}
	}
	
	function SetPageBreakBefore(pageBreak)
	{
		instructionRows[0].style.pageBreakBefore = pageBreak;
	}
	
	function AttachEvent(eventName, eventFunction)
	{
		if (!eventName || typeof(eventFunction) != "function")
		{
			return;
		}
		
		eventMap[eventName] = eventFunction;
	}
	
	function DetachEvent(eventName)
	{
		if (!eventName)
		{
			return;
		}
		
		eventMap[eventName] = null;
	}
	
	function DispatchEvent(eventName)
	{
		if (!enableDispatchEvents || !eventName || eventMap[eventName] == null)
		{
			return;
		}
		
		eventMap[eventName]();
	}
	
	function EnableEvents(enable)
	{
		enableDispatchEvents = enable;
	}
		
	function Destroy()
	{
		if (mapControl != null)
		{
			mapControl.Destroy();
		}
		mapControl = null;
		mapContainerDiv.parentNode.removeChild(mapContainerDiv);
		mapContainerDiv = null;
		defaultMapParams = null;
		for (var i = 0; i < instructionRows.length; i++)
		{
			instructionRows[i].parentNode.removeChild(instructionRows[i]);
			instructionRows[i] = null;
		}
		instructionRows.length = 0;
		instructionRows = null;
		
		mapControlInput.detachEvent("onclick",ToggleMap);
		mapRoute = null;
		eventMap.length = 0;
		eventMap = null;
	}
	
	this.GetMapControl = GetMapControl;
	this.ShowMap = ShowMap;
	this.HideMap = HideMap;
	this.ToggleMap = ToggleMap;
	this.Hide = Hide;
	this.Show = Show;
	this.IsVisible = IsVisible;
	this.MapVisible = MapVisible;
	this.GetHeight = GetHeight;
	this.SetBackgroundColor = SetBackgroundColor;
	this.SetPageBreakBefore = SetPageBreakBefore;
	this.AttachEvent = AttachEvent;
	this.DetachEvent = DetachEvent;
	this.EnableEvents = EnableEvents;
	this.Destroy = Destroy;
	
	CreateRowForInstructions();
}

//
// Class: VE_PrintableDirectionsManager
// Responsible for managing overview map and route
// instructions 
//
function VE_PrintableDirectionsManager(parentMap,
									route,
									overviewMapDivId,
									directionsTableDivId,
									ScratchPad,
									Collection,
									Searches,
									scratchPadTableDivId,
									collectionTableDivId,
									searchTableDivId,
									ParentDocument)
{
	// This is assuming the default margins of .75 inches at the top and bottom of the page
	var MAX_PRINT_PAGE_HEIGHT = 846;// 911 is the correct value, but 846 is approximately where some
									// type of cross-browser page breaking bug is breaking the page.

	var MAP_LARGE_SIZE_WIDTH = 650;
	var MAP_LARGE_SIZE_HEIGHT = 800;
	var MAP_MEDIUM_SIZE_WIDTH = 645;
	var MAP_MEDIUM_SIZE_HEIGHT = 470;
	var MAP_SMALL_SIZE_WIDTH  = 400;
	var MAP_SMALL_SIZE_HEIGHT = 300;
	
	var overviewMap = null;
	
	var instructionRows = new Array();
	
	var defaultMapParams = new Object();
	defaultMapParams.latitude  = parentMap.GetCenterLatitude();
	defaultMapParams.longitude = parentMap.GetCenterLongitude();
	var requestedMapStyle = parentMap.GetMapStyle();
	if (requestedMapStyle == "o")
	{
		defaultMapParams.mapstyle = "r";
		defaultMapParams.zoomlevel = "15";
		var hideStartupMap = true;
	}
	else
	{
		defaultMapParams.mapstyle = requestedMapStyle;
		defaultMapParams.zoomlevel = parentMap.GetZoomLevel();
	}
	defaultMapParams.fixedView = false;
	defaultMapParams.showDashboard = false;
	defaultMapParams.dashboardX = 5;
	defaultMapParams.dashboardY = 5;
	defaultMapParams.disableLogo = true;
	defaultMapParams.showScaleBar = true;
	var printRoute = route;
	var scratchPad = ScratchPad;
	var collection = Collection;
	var searches = Searches;
	var parentDocument = ParentDocument;

	var pushpins = parentMap.GetPushpins();
	
	var overviewMapDivRef = document.getElementById(overviewMapDivId);
	
	var directionsTableDivRef = document.getElementById(directionsTableDivId);
	var directionsTableBodyElm = null;
	var combinedInstructions = null;
	
	var scratchPadTableDivRef = document.getElementById(scratchPadTableDivId);
	var scratchPadTableBodyElm = null;
	var scratchPadVisible = scratchPad.isVisible() && scratchPad.getItems().getCount() > 0;
	
	var collectionTableDivRef = document.getElementById(collectionTableDivId);
	var collectionTableBodyElm = null;
	var collectionVisible = collection && collection.panel.el.parentNode;
	
	var searchTableDivRef = document.getElementById(searchTableDivId);
	var searchTableBodyElm = new Array();
	var searchCount = GetSearchCount(searches);

	var preferenceMapping = new Object();
	
	var currentPreset = "all";
	var currentSize   = "sizeM";
	
	// Controls whether or not the update page break method can execute.
	// Turn off when you are making a large number of visibility changes at once
	// then turn back on & execute UpdatePageBreaks() manually.
	var enableUpdatePageBreaks = false;
	
	function InitializePreferenceMapping()
	{
		preferenceMapping["all"] = OnAllPresetClicked;
		preferenceMapping["mapOnly"] = OnOnlyMapPresetClicked;
		preferenceMapping["directionsOnly"] = OnOnlyDirectionPresetClicked;
		preferenceMapping["showNotes"] = ShowNotes;
		preferenceMapping["hideNotes"] = HideNotes;
		preferenceMapping["showMap"] = ShowOverviewMap;
		preferenceMapping["hideMap"] = HideOverviewMap;
		preferenceMapping["sizeM"] = SetMapSizeMedium;
		preferenceMapping["sizeS"] = SetMapSizeSmall;
		preferenceMapping["sizeL"] = SetMapSizeLarge;
		preferenceMapping["showSummary"] = SetShowSummary;
		preferenceMapping["hideSummary"] = SetHideSummary;
		preferenceMapping["showDirections"] = ShowAllDirectionSteps;
		preferenceMapping["hideDirections"] = HideAllDirectionSteps;
		preferenceMapping["setShowAllInstructions"] = SetShowAllInstructions;
		preferenceMapping["showStartInstruction"] = SetShowStartInstructionOnly;
		preferenceMapping["showEndInstruction"] = SetShowEndInstructionOnly;
		preferenceMapping["showScratchPad"] = ShowAllScratchPadItems;
		preferenceMapping["hideScratchPad"] = HideAllScratchPadItems;
		preferenceMapping["showCollection"] = ShowAllCollectionItems;
		preferenceMapping["hideCollection"] = HideAllCollectionItems;
		preferenceMapping["showSearches"] = ShowAllSearches;
		preferenceMapping["hideSearches"] = HideAllSearches;
	}
	
	
	/**
	  * Create and initialize the overview map
	  */
	function CreateOverviewMap()
	{
		// Start out by setting the overview map container to medium size
		overviewMapDivRef.style.width = MAP_MEDIUM_SIZE_WIDTH;
		overviewMapDivRef.style.height = MAP_MEDIUM_SIZE_HEIGHT;
	
		// Use the preference cookie to get preference settings related to the overview map control.
		// This is necessary because of timing issues causing incorrect behavior when commands are 
		// issued immediately after creating the map control.
		var preferencesCookie = GetCookie("VE_PrintPreferences");
		if (preferencesCookie != null)
		{
			// Set the size of the map based on what's stored.
			if (preferencesCookie.indexOf("sizeS") > -1)
			{
				overviewMapDivRef.style.width = MAP_SMALL_SIZE_WIDTH;
				overviewMapDivRef.style.height = MAP_SMALL_SIZE_HEIGHT;
			}
			else if (preferencesCookie.indexOf("sizeL") > -1)
			{
				overviewMapDivRef.style.width = MAP_LARGE_SIZE_WIDTH;
				overviewMapDivRef.style.height = MAP_LARGE_SIZE_HEIGHT;
			}
		}
		
		overviewMap = new Msn.VE.MapControl(overviewMapDivRef, defaultMapParams);
	    overviewMap.Init();
	    
		for (var i = 0; i < pushpins.length; i++)
		{
			AddPrintPushpin(overviewMap, pushpins[i]);
		}

		if (printRoute)
		{
			overviewMap.AddLine("veDDHighlight", printRoute.latitudes, printRoute.longitudes, 5, "#00A9EB", 4, printRoute.routeRegionsByZoomLevel, printRoute.zoomLevelsForGeneralizedLines);
		}
	}
	
	function AddPrintPushpin(overviewMap, pushpin)
	{
		if (pushpin.pin.className == "VE_Pushpin VE_Pushpin_context" || 0 <= pushpin.pin.className.indexOf("VE_Traffic"))
		{
			// Don't add the context menu pushpin
			return;
		}

		// Format for printing
		var innerHTML;
		if (0 > pushpin.pin.innerHTML.indexOf("<img") && 0 > pushpin.pin.innerHTML.indexOf("<IMG"))
		{
			var pushpinRef = parentDocument.getElementById(pushpin.pin.id);
			if (pushpinRef)
			{
				var imageName = "";
				if (parentDocument.defaultView) // FireFox
				{
					var imageUrl = parentDocument.defaultView.getComputedStyle(pushpinRef, "").backgroundImage;
					imageName = imageUrl.substr(4, imageUrl.length - 5);
				}
				else // IE 6
				{
					var imageUrl = pushpinRef.currentStyle.backgroundImage;
					imageName = imageUrl.substr(5, imageUrl.length - 7);
				}

				if (imageName && imageName != "")
				{
					innerHTML = "<div class=VE_PrintPins_aN><IMG SRC=\"" + imageName + "\"/></div><div class=VE_PrintNumbers_aN>" + pushpin.pin.innerHTML + "</div>";
				}
			}
		}

		if (!innerHTML)
		{
			innerHTML = pushpin.pin.innerHTML;
		}

		overviewMap.AddPushpin(pushpin.id, pushpin.GetLatitude(), pushpin.GetLongitude(), 20, 14, pushpin.pin.className, innerHTML, pushpin.pin.style.zIndex, pushpin.pin.pinType);
	}


	// 
	// 
	//
	function CreateDirectionsTable()
	{
		if (printRoute)
		{
			directionsTableDivRef.innerHTML = "<table id=\"directionsTable\" cellspacing=\"0\">"+
				"<thead><tr id=\"directionsHeaderRow\"><td colspan=\"2\"><strong>"+ L_PrintableDirectionsManagerDirections_Text +"</strong></td><td style=\"text-align:right\"><strong>"+ L_PrintableDirectionsManagerDistance_Text +"</strong></td><td class=\"secondDirectionColumn\" style=\"text-align:right;padding-right:5px\"><strong>"+ L_PrintableDirectionsManagerDetailMap_Text +"</strong></td></tr></thead>"+
				"<tbody id=\"directionsTableBody\"></tbody>"+
			"</table> ";
			directionsTableBodyElm  = document.getElementById("directionsTableBody");
		}
	}
	/**
	  * creates a map zoom bar and overlays it in the top left corner of the overview map
	  */
	function CreateOverviewMapZoomControl()
	{
		var zoomContainer = document.createElement("div");
		zoomContainer.setAttribute("id","overmapZoomControl");
		
		var zoomOut = document.createElement("div");
		zoomOut.setAttribute("id","overmapZoomOut");
		zoomOut.attachEvent("onclick",OnOverviewMapZoomOut);
		
		var zoomIn  = document.createElement("div");
		zoomIn.setAttribute("id","overmapZoomIn");
		zoomIn.attachEvent("onclick",OnOverviewMapZoomIn);
		
		zoomContainer.appendChild(zoomOut);
		zoomContainer.appendChild(zoomIn);
		
		document.getElementById("overviewMapContainer").appendChild(zoomContainer);
		
	}
	/**
	  * Method responsible for grouping/combining individual steps to use
      * the same map control for multiple steps.
      * Algorithm taken from :http://msdn.microsoft.com/library/default.asp?url=/library/en-us/dnmapnet30/html/MWSCombine.asp
      */
	function CombineRouteInstructions()
	{
		if (printRoute)
		{
			var combinedInstructions = new Array();
			var instructions = printRoute.instructions;
			
			instructions[0].position = "Start";
			instructions[instructions.length-1].position = "End";
			var len = instructions.length;
			
			for(var i = 1;i<len-1;++i)
			{
				instructions[i].position = i;
			}
			var currentStart = 0;
			var currentEnd = 1;
			var numberOfCombinedSteps = 1;
			var currentlyCombinedSteps = 0; 
			var highestStepDistance = 0.0;
			//value is used to prevent short/long steps from being combined
			var lowestStepDistance = 0.0; 
			do 
			{
				var aCombinedInstruction = new VE_CombinedInstruction();
				aCombinedInstruction.AddInstruction(instructions[currentStart]);
				
				var stepFits = true;
				
				do
				{
					if(currentEnd >= len)
					{
						stepFits = false;
					}
					else 
					{
						if ((currentlyCombinedSteps < MAX_COMBINE_STEPS) && (currentEnd < (len-1)))					
						{
							stepFits = IsLatLongInRect(STEP_MAP_WIDTH,
																STEP_MAP_HEIGHT,
																instructions[currentStart].latitude,
																instructions[currentStart].longitude,
																instructions[currentEnd].latitude,
																instructions[currentEnd].longitude,
																overviewMap.GetZoomLevel());
							
							if(stepFits)
							{
								if(instructions[currentEnd].distance)
								{
									if (highestStepDistance == 0.0 && lowestStepDistance == 0.0) 
									{
										if (instructions[currentStart].distance > instructions[currentEnd].distance) 
										{
											highestStepDistance = instructions[currentStart].distance;
											lowestStepDistance = instructions[currentEnd].distance;
										} 
										else 
										{
											lowestStepDistance = instructions[currentStart].distance;
											highestStepDistance = instructions[currentEnd].distance;
										}
										
									}
									// Override highest/lowest distance values if warranted
									else 
									{
										if (instructions[currentEnd].distance > highestStepDistance) 
										{
											highestStepDistance = instructions[currentEnd].distance;
										}
										if (instructions[currentEnd].distance < lowestStepDistance) 
										{
											lowestStepDistance = instructions[currentEnd].distance;
										}
									}
									stepFits = (highestStepDistance / lowestStepDistance) <= 10;
								}
							}
						}
						else
						{
							stepFits = false; //max cominbe reached or last step
						}
						if(stepFits)
						{
							currentlyCombinedSteps++;
							aCombinedInstruction.AddInstruction(instructions[currentEnd]);
							currentEnd++;
							numberOfCombinedSteps++;
						}
						else 
						{
							currentlyCombinedSteps = 0;					
							currentStart = currentEnd;						
							currentEnd=currentStart+1;				
							lowestStepDistance = 0.0;
							highestStepDistance = 0.0;						
						}
					}
				}
				while(stepFits) ;
				combinedInstructions.push(aCombinedInstruction);
			}
			while(currentEnd < len);
			
			// Put the last step in it's own group
			var aCombinedInstruction = new VE_CombinedInstruction();
			aCombinedInstruction.AddInstruction(instructions[currentStart]);						
			combinedInstructions.push(aCombinedInstruction);		
			return combinedInstructions;
		}
	}
	//
	// Create a VE_StepRowView for each combined step and adds
	// it to the directions table body
	//
	function PopulateDirectionsView()
	{
		if (printRoute)
		{
			var stepsLen = combinedInstructions.length;
		
			for(var i  = 0; i < stepsLen ; i++) 
			{				
				var displayTurnByTurn = false;					
				if ( !directPrintOption )
				{	
					//Only display mini map for the first step.
					displayTurnByTurn = i == 0 ;
				}

				var stepRow = new VE_StepRowView(defaultMapParams,
												printRoute,
												combinedInstructions[i],
												directionsTableBodyElm,
												displayTurnByTurn);
				stepRow.AttachEvent("onmaptoggle", UpdateStepMapColumnVisibility);
				instructionRows.push(stepRow);
			} 
		}
	}
	
	function CreateTable(tableId, image, title, table)
	{
		tableId = CreateNormalizedText(tableId);
		image = CreateNormalizedText(image);
		title = CreateNormalizedText(title);
		return "<table class=\"PrintList\" id=\"" + tableId + "\" cellspacing=\"0\">"+
		"<thead><tr><td><img src=\"" + image + "\" /></td><td style=\"text-align:left; font-size:12pt\">" + title + "</td></tr></thead>"+
		"<tbody id=\"" + tableId + "Body\">" + table + "</tbody></table>";
	}
	
	function CreateTitleRow(className, number, title)
	{
		className = CreateNormalizedText(className);
		number = CreateNormalizedText(number);
		title = CreateNormalizedText(title);
		return "<td class=\"" + className + "_Row_Title1\">" + number + ":</td><td class=\"" + className + "_Row_Title2\">" + title + "</td>";
	}
	
	function CreateDescriptionRow(className, description)
	{
		className = CreateNormalizedText(className);
		description = CreateNormalizedText(description);
		return "<td class=\"" + className + "_Row_Description1\"></td><td class=\"" + className + "_Row_Description2\">" + description + "</td>";
	}
	
	//
	// The method takes crazy text and uses the document.createTextNode
	// method to make it just regular text.  No cross-site scripting!!!
	//
	function CreateNormalizedText(text)
	{
		var textNode = document.createTextNode(text);
		var textOuterNode = document.createElement("span");
		textOuterNode.appendChild(textNode);
		return textOuterNode.innerHTML;
	}

	//
	// Create and fill the scratch pad table body with info or something!
	//
	function PopulateScratchPadView()
	{
		if (scratchPadVisible)
		{
			var itemLen = scratchPad.getItems().getCount();
			
			var table = "";
			for(var i = 0; i < itemLen; i++)
			{
				var item = scratchPad.getItems().retrieveByIndex(i);
				if (item)
				{
					table += "<tr>" + CreateTitleRow("ScratchPad", i+1, item.getTitle()) + "</tr>";
					table += "<tr>" + CreateDescriptionRow("ScratchPad", item.getDescription()) + "</tr>";
				}
			}

			scratchPadTableDivRef.innerHTML = CreateTable("scratchPadTable", "i/pins/poi_usergenerated.gif", L_PrintableDirectionsManagerScratchPadTitle_Text, table);
			scratchPadTableBodyElm = document.getElementById("scratchPadTableBody");
		}
	}
	//
	// Create and fill the collection table body with info or something!
	//
	function PopulateCollectionView()
	{
		if (collectionVisible)
		{
			var itemLen = collection.Annotations.length;
			
			var table = "";
			for(var i = 0; i < itemLen; i++)
			{
				table += "<tr>" + CreateTitleRow("Collection", i+1, collection.Annotations[i].Title) + "</tr>";
				table += "<tr>" + CreateDescriptionRow("Collection", collection.Annotations[i].Notes) + "</tr>";
			}
			
			collectionTableDivRef.innerHTML = CreateTable("collectionTable", "i/pins/poi_viewer.gif", collection.title, table);
			collectionTableBodyElm = document.getElementById("collectionTableBody");
		}
	}
	//
	// Create and fill the search tables with info or something!
	//
	function PopulateSearchViews()
	{
		if (searchCount > 0)
		{
			var allTables = "";
			for(var i=0; i < searchCount; i++)
			{
				// Step 1: Build the rows
				var table = "";
				var length = searches[i].results.length;
				if (length > 0)
				{
					var half = parseInt((length + 1)/2);
					for(var j=0; j<half; j++)
					{
						table += "<tr>" + CreateTitleRow("Search", j+1, searches[i].results[j].name);
						table += (j + half < length) ? CreateTitleRow("Search", j+1+half, searches[i].results[j+half].name) : "";
						table += "</tr>";
						table += "<tr>" + CreateDescriptionRow("Search", searches[i].results[j].description);
						table += (j + half < length) ? CreateDescriptionRow("Search", searches[i].results[j+half].description) : "";
						table += "</tr>";
						table += "<tr>" + CreateDescriptionRow("Search", searches[i].results[j].phone);
						table += (j + half < length) ? CreateDescriptionRow("Search", searches[i].results[j+half].phone): "";
						table += "</tr>";
					}
					
					// Step 2: Construct the table and append it to previous tables
					allTables += CreateTable("searchTable" + (i+1), "i/pins/poi_" + searches[i].color + ".gif", L_PrintableDirectionsManagerSearchTitle_Text + " \"" + searches[i].phrase + "\"", table);
				}
			}
			
			// Step 3: store this table where it belongs!
			searchTableDivRef.innerHTML = allTables;
			
			// Step 4: Grab the table body references
			for(i=0; i < searchCount; i++)
			{
				var searchTable = document.getElementById("searchTable" + (i+1) + "Body");
				if (searchTable)
					searchTableBodyElm.push(searchTable);
			}
		}
	}
	//
	//	Set the alternating row colors for the directions table
	//
	function SetRowColors()
	{
		if (printRoute)
		{
			var visibleRowCount  = 0;
			for (var i = 0; i < instructionRows.length; i++)
			{
				var rowColor = visibleRowCount % 2 == 1 && instructionRows[i].IsVisible() ? "#E9F1F7" : "#FFFFFF";

				instructionRows[i].SetBackgroundColor(rowColor);
				
				if (instructionRows[i].IsVisible())
				{
					visibleRowCount++;
				}
			}
		}
	}
	// Summary display methods
	function SetStartSummaryView()
	{
		if (printRoute)
		{
			document.getElementById("summaryStart").innerHTML = IOSec.EncodeHtml(printRoute.startAddress);
		}
	}
	
	function SetEndSummaryView()
	{
		if (printRoute)
		{
			document.getElementById("summaryEnd").innerHTML = IOSec.EncodeHtml(printRoute.endAddress);
		}
	}
	
	function SetDistanceSummaryView()
	{
		if (printRoute)
		{
			document.getElementById("summaryDistance").innerHTML = printRoute.distance+ " "+printRoute.distanceUnit;
		}
	}
	
	function SetTimeSummaryView()
	{
		if (printRoute)
		{
			document.getElementById("summaryTime").innerHTML = printRoute.time;
		}
	}
	
	
	function ShowOverviewMap() 
	{
		overviewMapDivRef.style.display = "block";
		overviewMapCheckbox.checked = true;
	}
	
	function HideOverviewMap()
	{
		overviewMapDivRef.style.display = "none";
		overviewMapCheckbox.checked = false;
	}
	
	function ToggleOverviewMap() 
	{
		overviewMapDivRef.style.display == "block" ? HideOverviewMap() : ShowOverviewMap();
		UpdatePageBreaks();
	}
	
	function ToggleAllDirectionSteps() 
	{
		if (printRoute)
		{
			directionsTableDivRef.style.display == "block" ? HideAllDirectionSteps() : ShowAllDirectionSteps();
			UpdatePageBreaks();
		}
	}
	
	function ShowAllDirectionSteps()
	{
		if (printRoute)
		{
			directionsTableDivRef.style.display = "block";
			directionsCheckbox.checked = true;
		}
	}
	
	function HideAllDirectionSteps()
	{
		if (printRoute)
		{
			directionsTableDivRef.style.display = "none";
			directionsCheckbox.checked = false;
		}
	}
	
	function HideAllTurnByTurnMaps()
	{
		for(var i=0; i<instructionRows.length; ++i)
		{
			instructionRows[i].HideMap();
		}
	}
	
	function ToggleAllScratchPadItems()
	{
		if (scratchPadVisible)
		{
			scratchPadTableDivRef.style.display == "block" ? HideAllScratchPadItems() : ShowAllScratchPadItems();
			UpdatePageBreaks();
		}
	}
	
	function ShowAllScratchPadItems()
	{
		if (scratchPadVisible)
		{
			scratchPadTableDivRef.style.display = "block";
			scratchPadCheckbox.checked = true;
			ShowPushpins("VE_Pushpin_aN");
		}
	}
	
	function HideAllScratchPadItems()
	{
		if (scratchPadVisible)
		{
			scratchPadTableDivRef.style.display = "none";
			scratchPadCheckbox.checked = false;
			HidePushpins("VE_Pushpin_aN");
		}
	}
	
	function ToggleAllCollectionItems()
	{
		if (collectionVisible)
		{
			collectionTableDivRef.style.display == "block" ? HideAllCollectionItems() : ShowAllCollectionItems();
			UpdatePageBreaks();
		}
	}
	
	function ShowAllCollectionItems()
	{
		if (collectionVisible)
		{
			collectionTableDivRef.style.display = "block";
			collectionCheckbox.checked = true;
			ShowPushpins("VE_Pushpin_viewer");
		}
	}
	
	function HideAllCollectionItems()
	{
		if (collectionVisible)
		{
			collectionTableDivRef.style.display = "none";
			collectionCheckbox.checked = false;
			HidePushpins("VE_Pushpin_viewer");
		}
	}
	
	function ToggleAllSearches()
	{
		if (searchCount > 0)
		{
			searchTableDivRef.style.display == "block" ? HideAllSearches() : ShowAllSearches();
			UpdatePageBreaks();
		}
	}
	
	function ShowAllSearches()
	{
		if (searchCount > 0)
		{
			searchTableDivRef.style.display = "block";
			searchCheckbox.checked = true;
			ShowPushpins("VE_Pushpin_search1");
			ShowPushpins("VE_Pushpin_search2");
			ShowPushpins("VE_Pushpin_search3");
		}
	}
	
	function HideAllSearches()
	{
		if (searchCount > 0)
		{
			searchTableDivRef.style.display = "none";
			searchCheckbox.checked = false;
			HidePushpins("VE_Pushpin_search1");
			HidePushpins("VE_Pushpin_search2");
			HidePushpins("VE_Pushpin_search3");
		}
	}

	function HidePushpins(className)
	{
		DisplayPushpins(className, "none");
	}
	function ShowPushpins(className)
	{
		DisplayPushpins(className, "block");
	}
	function DisplayPushpins(className, display)
	{
		var items = document.getElementsByTagName("a");
		for(var i=0; i<items.length; ++i)
		{
			if (0 <= items[i].className.indexOf(className))
			{
				items[i].style.display = display;
			}
		}
	}
	
	//Show the start point in the overview map
	function ShowStartPoint()
	{
		if (printRoute)
		{
			var instruction =printRoute.instructions[0];
			overviewMap.SetCenterAndZoom(instruction.latitude,
										 instruction.longitude,
										 15);
		}
	}
	//show the end point in the overview map
	function ShowEndPoint()
	{
		if (printRoute)
		{
			var instructions =printRoute.instructions;		
			overviewMap.SetCenterAndZoom(instructions[instructions.length-1].latitude,
								         instructions[instructions.length-1].longitude,
								         15);
		}
	}
	
	function ShowEntireRoute()
	{
		if (printRoute)
		{
			var rect = printRoute.bestViewRectangle;
		    overviewMap.SetViewport(rect[0].latitude,
									rect[0].longitude,
									rect[1].latitude,
									rect[1].longitude);
			// This is an utter hack to get a bug in the map control when a resize & then changing the view are issued
			// one after the other.  If we don't do this, the map control will be off center for the large map size.
			overviewMap.PanMap(-1, 0);
			overviewMap.PanMap(1, 0);
		}
		else
		{
			// TODO: (mmurphey) This is where we make sure the map is the correct size!
		}
	}
	
	function SetMapSizeSmall()
	{		
		overviewMap.SetAnimationEnabled(false);
		overviewMap.Resize(MAP_SMALL_SIZE_WIDTH,MAP_SMALL_SIZE_HEIGHT);
		document.getElementById("smallMapSizeLink").checked = true;
		overviewMap.PanMap(-1, 0);
		overviewMap.PanMap(1, 0);
		overviewMap.SetAnimationEnabled(true);
		currentSize = "sizeS";
		UpdatePageBreaks();
	}
	
	function SetMapSizeLarge()
	{
		overviewMap.SetAnimationEnabled(false);
		overviewMap.Resize(MAP_LARGE_SIZE_WIDTH,MAP_LARGE_SIZE_HEIGHT);
		document.getElementById("largeMapSizeLink").checked = true;
		overviewMap.PanMap(-1, 0);
		overviewMap.PanMap(1, 0);
		overviewMap.SetAnimationEnabled(true);	
		currentSize = "sizeL";
		UpdatePageBreaks();
	}
	
	function SetMapSizeMedium()
	{
		overviewMap.SetAnimationEnabled(false);
		overviewMap.Resize(MAP_MEDIUM_SIZE_WIDTH,MAP_MEDIUM_SIZE_HEIGHT);
		document.getElementById("mediumMapSizeLink").checked = true;
		overviewMap.PanMap(-1, 0);
		overviewMap.PanMap(1, 0);
		overviewMap.SetAnimationEnabled(true);
		currentSize = "sizeM";
		UpdatePageBreaks();
	}
	
	function SetMapStyle()
	{
		var style = overviewMap.GetMapStyle();
		if (style == 'r')
		{
			OnRoadStyleClick();
		}
		else if (style == 'h')
		{
			OnArialStyleClick();
			SetShowArialLabels();
		}
		else if (style == 'a')
		{
			OnArialStyleClick();
			SetHideArialLabels();
		}
	}
	
	function SetShowStartInstructionOnly()
	{
		document.getElementById("directionsStart").checked = true;
		var numRowsToShow = Math.min(MAX_STEPS_START_END,
								Math.max(MIN_STEPS_START_END,instructionRows.length/3));
		
		if(numRowsToShow < instructionRows.length)
		{
			for(var i = 0; i < instructionRows.length; ++i)
			{
				if(i < numRowsToShow)
				{
					instructionRows[i].Show();
				}
				else 
				{
					instructionRows[i].Hide();
				}
			}
		
			RemoveElementById("endMoreStepsRow");
			AddStartMoreRow();
			SetRowColors();
		}
		UpdatePageBreaks();
	}
	
	function CreateEllipsisRow(id)
	{
		var moreEllipsis = document.createElement("tr");
		var cell = document.createElement("td");
		cell.colSpan = 4;
		cell.innerHTML = L_PrintableDirectionsManagerMoreSteps_Text;
		cell.className = "finalCombinedStepCell";
		moreEllipsis.setAttribute("id",id);
		moreEllipsis.appendChild(cell);
		return moreEllipsis;
	}
	
	function AddEndMoreRow()
	{
		var moreEllipsis = document.getElementById("endMoreStepsRow");
		if(!moreEllipsis)
		{
			moreEllipsis = CreateEllipsisRow("endMoreStepsRow");
			directionsTableBodyElm.insertBefore(moreEllipsis,directionsTableBodyElm.firstChild);
		}
	}
	function AddStartMoreRow()
	{
		var moreEllipsis = document.getElementById("startMoreStepsRow");
		if(!moreEllipsis)
		{
			moreEllipsis = CreateEllipsisRow("startMoreStepsRow");
			directionsTableBodyElm.appendChild(moreEllipsis);
		}
	}
	function RemoveElementById(id)
	{		
		var elm = document.getElementById(id);
		if(elm && 
		   elm.parentNode)
		{			
			elm.parentNode.removeChild(elm);
		}
	}
	function SetShowEndInstructionOnly()
	{
		document.getElementById("directionsEnd").checked = true;
		var numRowsToShow = Math.min(MAX_STEPS_START_END,
								Math.max(MIN_STEPS_START_END,instructionRows.length/3));
		if(numRowsToShow < instructionRows.length)
		{
			for(var i = 0; i < instructionRows.length; ++i)
			{
				if(i < instructionRows.length-numRowsToShow)
				{
					instructionRows[i].Hide();
				}
				else 
				{
					instructionRows[i].Show();
				}				
			}
			AddEndMoreRow();
			RemoveElementById("startMoreStepsRow");
			SetRowColors();
		}		
		UpdatePageBreaks();
	}
	
	function SetShowAllInstructions()
	{
		if (printRoute)
		{
			document.getElementById("directionsAll").checked = true;
			for(var i = 0; i < instructionRows.length; ++i)
			{
				instructionRows[i].Show();
			}
			RemoveElementById("endMoreStepsRow");
			RemoveElementById("startMoreStepsRow");
			SetRowColors();
			UpdatePageBreaks();
		}
	}
	
	function GetOverviewMap()
	{
		return overviewMap;
	}
	
	// Updates page breaks based on visible elements.
	// In theory we should not need this, but in practice we do because browsers perform
	// badly when trying to divide things over page breaks.
	function UpdatePageBreaks()
	{
		// Exit if updates are disabled.
		if (!enableUpdatePageBreaks)
		{
			return;
		}
		
		///////////////////////////////////////////////////////////////////////
		// Grab the visibility of the major sections.
		///////////////////////////////////////////////////////////////////////
		var overviewMapShowing = overviewMapCheckbox.checked;
		var summaryShowing = printRoute ? document.getElementById("toggleSummaryBox").checked : false;
		var directionsShowing = printRoute ? directionsCheckbox.checked : false;
		var scratchPadShowing = scratchPadVisible ? scratchPadCheckbox.checked : false;
		var collectionShowing = collectionVisible ? collectionCheckbox.checked : false;
		var searchesShowing = (searchCount > 0) ? searchCheckbox.checked : false;
		var notesShowing = document.getElementById("toggleNotesBox").checked;
		
		var pageLength = document.getElementById("msnVEHeader").offsetHeight;
		
		///////////////////////////////////////////////////////////////////////
		// Check the overview map
		///////////////////////////////////////////////////////////////////////
		if (overviewMapShowing)
		{
			pageLength += overviewMapDivRef.offsetHeight;
			pageLength += 10; // overviewMapDivRef.style.margin-bottom
		}
		
		///////////////////////////////////////////////////////////////////////
		// Check the Summary
		///////////////////////////////////////////////////////////////////////
		var summaryContainer = document.getElementById("summaryContainer");
		if (printRoute && summaryShowing && summaryContainer)
		{
			// Increment the page length
			pageLength += summaryContainer.offsetHeight;
			
			if (pageLength > MAX_PRINT_PAGE_HEIGHT)
			{
				summaryContainer.style.pageBreakBefore = "always";
				pageLength = summaryContainer.offsetHeight;
			}
			else
			{
				summaryContainer.style.pageBreakBefore = "";
			}
		}

		///////////////////////////////////////////////////////////////////////
		// Check the directions
		///////////////////////////////////////////////////////////////////////
		if (printRoute && directionsShowing)
		{
			// Reset the header.
			var directionsHeaderRow = document.getElementById("directionsHeaderRow");
			directionsHeaderRow.style.pageBreakBefore = "";
			var directionsHeaderRowHeight = directionsHeaderRow.offsetHeight;
			
			var showEndOnlyEllipsisRow = document.getElementById("directionsEnd").checked;
			var ellipsisRowHeight = showEndOnlyEllipsisRow ? document.getElementById("endMoreStepsRow").offsetHeight : 0;
			
			// Add some for the header.
			pageLength += 2; // The directions border
			pageLength += 10; // directionsViewContainer.style.margin-bottom
			pageLength += directionsHeaderRowHeight; // the header
			
			// If directions is set to "end only", 
			// Add some for the ellipsis row
			if (showEndOnlyEllipsisRow)
			{			
				pageLength += ellipsisRowHeight;				
			}
			
			for (var i = 0; i < instructionRows.length; ++i)
			{
				var currentInstructionRow = instructionRows[i];
				
				var rowHeight = currentInstructionRow.GetHeight();
				if (currentInstructionRow.IsVisible())
				{
					pageLength += rowHeight;
				}
				
				// Insert a page break if necessary.
				if (currentInstructionRow.IsVisible() && pageLength >= MAX_PRINT_PAGE_HEIGHT)
				{
					// If this is the first instruction (including ellipsis rows), move the header down with you.
					if (i == 0)
					{
						currentInstructionRow.SetPageBreakBefore("");
						directionsHeaderRow.style.pageBreakBefore = "always";
						pageLength = directionsHeaderRowHeight + rowHeight + ellipsisRowHeight;
					}
					else
					{
						currentInstructionRow.SetPageBreakBefore("always");
						pageLength = rowHeight;
						pageLength += 2; // The directions border
						pageLength += 10; // directionsViewContainer.style.margin-bottom
						
						// The mozilla print shows the table header at the top of every
						// new page.
						if (navigator.userAgent.indexOf("IE") < 0)
							pageLength += directionsHeaderRowHeight; // the header
					}
				}
				else
				{
					currentInstructionRow.SetPageBreakBefore("");
				}
			}
		}
		
		///////////////////////////////////////////////////////////////////////
		// Check the scratch pad
		///////////////////////////////////////////////////////////////////////
		if (scratchPadVisible && scratchPadShowing)
		{
			pageLength = PageBreakChildNodes(document.getElementById("scratchPadTable"), pageLength, 20, 2);
		}

		///////////////////////////////////////////////////////////////////////
		// Check the collection
		///////////////////////////////////////////////////////////////////////
		if (collectionVisible && collectionShowing)
		{
			pageLength = PageBreakChildNodes(document.getElementById("collectionTable"), pageLength, 10, 2);
		}


		///////////////////////////////////////////////////////////////////////
		// Check the searches
		///////////////////////////////////////////////////////////////////////
		if (searchCount > 0 && searchesShowing)
		{
			for (var j=0; j<searchCount; j++)
			{
				pageLength = PageBreakChildNodes(document.getElementById("searchTable" + (j+1)), pageLength, 10, 3);
			}
		}
	}
	
	//
	// Helper function to insert page breaks into the table nodes
	//
	function PageBreakChildNodes(table, pageLength, tableMargins, totalRows)
	{
		if (!table)
			return;

		var childNodes = table.childNodes[1].childNodes;
		var headerRow = table.firstChild.firstChild;

		pageLength += tableMargins + headerRow.offsetHeight;
		headerRow.style.pageBreakBefore = "";
			
		if (pageLength >= MAX_PRINT_PAGE_HEIGHT)
		{
			pageLength = headerRow.offsetHeight + tableMargins;
			headerRow.style.pageBreakBefore = "always";
		}
			
		for (var i = 0; i < childNodes.length; i++)
		{
			var currentRow = childNodes[i];
			
			var rowHeight = currentRow.offsetHeight;
			pageLength += rowHeight;
			if (pageLength >= MAX_PRINT_PAGE_HEIGHT)
			{
				if (i < totalRows)
				{
					headerRow.style.pageBreakBefore = "always";
					pageLength = headerRow.offsetHeight + tableMargins;
					for(var j=0; j< totalRows; ++j)
					{
						childNodes[j].style.pageBreakBefore = "";
						pageLength += childNodes[j].offsetHeight;				
					}
				}
				else if (i % totalRows != 0)
				{
					var backupCount = i % totalRows;
					pageLength = tableMargins;
					for(var j=i-backupCount; j<=i; ++j)
					{
						childNodes[j].style.pageBreakBefore = "";
						pageLength += childNodes[j].offsetHeight;				
					}
					childNodes[i-backupCount].style.pageBreakBefore = "always";
				}
				else
				{
					currentRow.style.pageBreakBefore = "always";
					pageLength = rowHeight + tableMargins;

					// The mozilla print shows the table header at the top of every
					// new page.
					if (navigator.userAgent.indexOf("IE") < 0)
						pageLength += headerRow.offsetHeight; // the header
				}
			}
			else
			{
				currentRow.style.pageBreakBefore = "";
			}
		}
		return pageLength;
	}
	
	function UpdateStepMapColumnVisibility()
	{
		// First update the page breaks
		UpdatePageBreaks();
	
		// First check if we can even get to the print media stylesheet rules.
		var printMediaCSSRules = GetCssRulesForStylesheet(document.styleSheets[1]);
		if (printMediaCSSRules == null)
		{
			return;
		}

		var anyMapsVisible = false;
		for(var i = 0; !anyMapsVisible && i < instructionRows.length; ++i)
		{
			anyMapsVisible |= instructionRows[i].MapVisible();
		}

		// Toggle the visibility of the column according to whether or not we have any
		// step maps visible
		if (anyMapsVisible)
		{
			printMediaCSSRules[printMediaCSSRules.length - 1].style.cssText = "";
		}
		else
		{
			printMediaCSSRules[printMediaCSSRules.length - 1].style.cssText = "display:none";
		}
	}
	
	function ShowAllStepMaps()
	{
		for(var i = 0; i < instructionRows.length; ++i)
		{
			instructionRows[i].EnableEvents(false);
			instructionRows[i].ShowMap();
			instructionRows[i].EnableEvents(true);
		}
		UpdateStepMapColumnVisibility();
	}
		
	function ShowNotes()
	{
		document.getElementById("notesTableContainer").style.display = "block";
		document.getElementById("toggleNotesBox").checked = true;
	}
	
	function HideNotes()
	{
		document.getElementById("notesTableContainer").style.display = "none";
		document.getElementById("toggleNotesBox").checked = false;
	}
	
	function ToggleNotes()
	{
		var elm = document.getElementById("notesTableContainer");
		if(elm.style.display == "none")
		{
			ShowNotes();
		}
		else
		{
			HideNotes();
		}
		UpdatePageBreaks();
	}
	function SetShowSummary()
	{
		if (printRoute)
		{
			document.getElementById("summaryContainer").style.display = "block";
			document.getElementById("toggleSummaryBox").checked = true;
		}
	}
	function SetHideSummary()
	{
		if (printRoute)
		{
			document.getElementById("summaryContainer").style.display = "none";
			document.getElementById("toggleSummaryBox").checked = false;
		}
	}
	function SetShowArialLabels()
	{
		overviewMap.SetMapStyle('h');
		document.getElementById("arialLabelsToggle").checked = true;
	}
	function SetHideArialLabels()
	{
		overviewMap.SetMapStyle('a');
		document.getElementById("arialLabelsToggle").checked = false;
	}
	
	function LoadPreferences()
	{
		if(GetCookie("VE_PrintPreferences")) 
		{
			var funcNames = GetCookie("VE_PrintPreferences").split(",");
			for(var func in funcNames)
			{			
				if(preferenceMapping[funcNames[func]])
				{
					preferenceMapping[funcNames[func]]();
				}
			}	
		}	
		else 
		{
			//no preferences stored, show everything
			OnAllPresetClicked();
		}
		
		if (hideStartupMap)
		{
			HideOverviewMap();
		}
	}
	
	function SavePreferences()
	{		
		SetCookie("VE_PrintPreferences",BuildPreferenceString());
	}
	
	function BuildPreferenceString()
	{
		var prefs = currentPreset+","+currentSize;
		
		if (printRoute)
		{
			if(document.getElementById("toggleSummaryBox").checked)
			{
				prefs+=",showSummary";
			}
			else 
			{
				prefs+=",hideSummary";
			}
			if (directionsCheckbox.checked)
			{
				prefs+=",showDirections";
			}
			else
			{
				prefs+=",hideDirections";
			}
			if (document.getElementById("directionsAll").checked)
			{
				prefs+=",setShowAllInstructions";
			}
			else if (document.getElementById("directionsStart").checked)
			{
				prefs+=",showStartInstruction";
			}
			else if (document.getElementById("directionsEnd").checked)
			{
				prefs+=",showEndInstruction";
			}
		}
		if(document.getElementById("toggleNotesBox").checked)
		{
			prefs+=",showNotes";
		}
		else 
		{
			prefs+=",hideNotes";
		}
		if(overviewMapCheckbox.checked)
		{
			prefs+=",showMap";
		}
		else 
		{
			prefs+=",hideMap";
		}
		if (scratchPadVisible)
		{
			if (scratchPadCheckbox.checked)
			{
				prefs+=",showScratchPad";
			}
			else
			{
				prefs+=",hideScratchPad";
			}
		}
		if (collectionVisible)
		{
			if (collectionCheckbox.checked)
			{
				prefs+=",showCollection";
			}
			else
			{
				prefs+=",hideCollection";
			}
		}
		if (searchCount > 0)
		{
			if (searchCheckbox.checked)
			{
				prefs+=",showSearches";
			}
			else
			{
				prefs+=",hideSearches";
			}
		}
		
		return prefs;
	}

	function Destroy()
	{
		if ( !directPrintOption )
		{
			SavePreferences();
		}

		overviewMap.Destroy();
		overviewMap = null;

		var rowElm = null;
		while(rowElm = instructionRows.pop())
		{
			rowElm.Destroy();
			rowElm = null;
		}
		instructionRows = null;

		if (printRoute)
		{
			directionsTableBodyElm.parentNode.removeChild(directionsTableBodyElm);
			directionsTableBodyElm = null;
			directionsTableDivRef.parentNode.removeChild(directionsTableDivRef);
			directionsTableDivRef = null;
			printRoute = null;
		}
		
		if (scratchPadVisible)
		{
			scratchPadTableBodyElm.parentNode.removeChild(scratchPadTableBodyElm);
			scratchPadTableBodyElm = null;
			scratchPadTableDivRef.parentNode.removeChild(scratchPadTableDivRef);
			scratchPadTableDivRef = null;
		}
		scratchPad = null;
		
		if (collectionVisible)
		{
			collectionTableBodyElm.parentNode.removeChild(collectionTableBodyElm);
			collectionTableBodyElm = null;
			collectionTableDivRef.parentNode.removeChild(collectionTableDivRef);
			collectionTableDivRef = null;
		}
		collection = null;

		if (searchCount > 0)
		{
			var bodyElm = null;
			while(bodyElm = searchTableBodyElm.pop())
			{
				bodyElm.parentNode.removeChild(bodyElm);
				bodyElm = null;
			}
			searchTableBodyElm = null;
			searchTableDivRef.parentNode.removeChild(searchTableDivRef);
			searchTableDivRef = null;
		}
		searches = null;
		
		overviewMapCheckbox.detachEvent("onclick",OnOverviewMapCheckboxClick);
		
		document.getElementById("roadStyleLink").detachEvent("onclick",OnRoadStyleClick);
		document.getElementById("arialStyleLink").detachEvent("onclick",OnArialStyleClick);
		
		document.getElementById("topPrint").detachEvent("onclick",OnPrintClick);
		document.getElementById("bottomPrint").detachEvent("onclick",OnPrintClick);
		
		document.getElementById("smallMapSizeLink").detachEvent("onclick",OnMapResizeSmall);
		document.getElementById("mediumMapSizeLink").detachEvent("onclick",OnMapResizeMedium);
		document.getElementById("largeMapSizeLink").detachEvent("onclick",OnMapResizeLarge);
	
		if (printRoute)
		{
			document.getElementById("showStartLink").detachEvent("onclick",OnStartClick);
			document.getElementById("showEndLink").detachEvent("onclick",OnEndClick);
			document.getElementById("showEntireLink").detachEvent("onclick", OnEntireClick);

			document.getElementById("directionsStart").detachEvent("onclick",OnShowStartInstructionOnly);
			document.getElementById("directionsAll").detachEvent("onclick",OnShowAllInstructions);
			document.getElementById("directionsEnd").detachEvent("onclick",OnShowEndInstructionOnly);
	
			directionsCheckbox.detachEvent("onclick",OnDirectionCheckboxClick);
			document.getElementById("toggleSummaryBox").detachEvent("onclick",OnSummaryToggle);	
		}
		if (scratchPadVisible)
		{
			scratchPadCheckbox.detachEvent("onclick",OnScratchPadCheckboxClick);
		}
		if (collectionVisible)
		{
			collectionCheckbox.detachEvent("onclick",OnCollectionCheckboxClick);		
		}
		if (searchCount > 0)
		{
			searchCheckbox.detachEvent("onclick",OnSearchCheckboxClick);
		}
		
		document.getElementById("toggleNotesBox").detachEvent("onclick",OnNotesToggle);
		
		document.getElementById("arialLabelsToggle").detachEvent("onclick",OnToggleArialLabels);
	
		document.getElementById("everythingOnPresetLink").detachEvent("onclick",OnAllPresetClicked);
		document.getElementById("overmapOnlyPresetLink").detachEvent("onclick",OnOnlyMapPresetClicked);
		document.getElementById("instructionsOnlyPresetLink").detachEvent("onclick",OnOnlyDirectionPresetClicked);
		
		document.getElementById("notesText").detachEvent("onkeyup",OnNotesKeyUp);
		
		//window.detachEvent("onbeforeprint",OnPrintClick);
		
	}
	this.GetOverviewMap          = GetOverviewMap;
	this.SetStartSummaryView     = SetStartSummaryView;
	this.SetEndSummaryView       = SetEndSummaryView;
	this.SetDistanceSummaryView  = SetDistanceSummaryView;
	this.SetTimeSummaryView      = SetTimeSummaryView;
	this.ShowOverviewMap         = ShowOverviewMap;
	this.HideOverviewMap         = HideOverviewMap;
	this.ToggleOverviewMap       = ToggleOverviewMap;
	this.ToggleAllDirectionSteps = ToggleAllDirectionSteps;
	this.ShowAllDirectionSteps   = ShowAllDirectionSteps;
	this.HideAllDirectionSteps   = HideAllDirectionSteps;
	this.ToggleAllScratchPadItems = ToggleAllScratchPadItems;
	this.ShowAllScratchPadItems   = ShowAllScratchPadItems;
	this.HideAllScratchPadItems	  = HideAllScratchPadItems;
	this.ToggleAllCollectionItems = ToggleAllCollectionItems;
	this.ShowAllCollectionItems   = ShowAllCollectionItems;
	this.HideAllCollectionItems	  = HideAllCollectionItems;
	this.ToggleAllSearches		  = ToggleAllSearches;
	this.ShowAllSearches		  = ShowAllSearches;
	this.HideAllSearches		  = HideAllSearches;
	
	this.Destroy = Destroy;
	this.FireDirectPrintAction = FireDirectPrintAction;
		
	//Initializing code
	InitializePreferenceMapping();
	CreateOverviewMap();
	CreateDirectionsTable();
	CreateOverviewMapZoomControl();
	
	var overviewMapCheckbox = document.getElementById("toggleOverviewMapBox");
	var directionsCheckbox  = document.getElementById("displayDirectionsCheckbox");
	var scratchPadCheckbox  = document.getElementById("displayScratchPadCheckbox");
	var collectionCheckbox  = document.getElementById("displayCollectionCheckbox");
	var searchCheckbox      = document.getElementById("displaySearchCheckbox");

	combinedInstructions = CombineRouteInstructions();
	PopulateDirectionsView();
	SetRowColors();
	PopulateScratchPadView();
	PopulateCollectionView();
	PopulateSearchViews();

	//ShowOverviewMap();	
	ShowAllDirectionSteps();
	SetStartSummaryView();
	SetEndSummaryView();
	SetDistanceSummaryView();
	SetTimeSummaryView();

	SetMapSizeMedium();
	SetMapStyle();
		
	LoadPreferences();
	enableUpdatePageBreaks = true;
	UpdatePageBreaks();
	
	//Event handlers
	function OnOverviewMapCheckboxClick(e)
	{
		ToggleOverviewMap();
	}
	
	overviewMapCheckbox.attachEvent("onclick",OnOverviewMapCheckboxClick);
	
	function OnRoadStyleClick(e)
	{
		overviewMap.SetMapStyle('r');
		document.getElementById("showLabelsContainer").style.visibility = "hidden";
		document.getElementById("roadStyleLink").checked = true;
	}
	
	function OnArialStyleClick(e)
	{
		overviewMap.SetMapStyle('h');
		document.getElementById("showLabelsContainer").style.visibility  = "visible";
		document.getElementById("arialLabelsToggle").checked = true;
		document.getElementById("arialStyleLink").checked = true;
	}
	
	function OnStartClick(e)
	{
		ShowStartPoint();
	}
	
	function OnEndClick(e)
	{
		ShowEndPoint();
	}
	function OnEntireClick(e)
	{
		ShowEntireRoute();
	}
	
	function OnPrintClick(e)
	{
		var typeYourNotesText = "[" + L_PrintableDirectionsManagerTypeYourNotes_Text + "]" ;
		if(document.getElementById("notesText").value == typeYourNotesText )
		{
			HideNotes();
		}
		
		//set a time delay for printing to allow the map to be completely loaded[ set only for direct print options.]
		if ( setTimerOption )
		{	
			window.setTimeout(Print, printDelay);
			setTimerOption = false;
		}
		else
		{
			Print();
		}	
		
	}
	function ClearPrintLogCache()
	{
		try
		{
			var elname = "s_i_" + window.parent.window.s_account;
			var el = window.parent.window.document.getElementById(elname);
			if(el != null)
			{
				el.src = "";
			}
			el = document.getElementById(elname);
			if(el != null)
			{
				el.src = "";
			}
			
		}
		catch(exp)
		{
		}
	}	
	function Print()
	{				
		if ( directPrintOption )
		{			
			//remove any pop-up messages, reset focus to the hiddenIframeForPrintDirections window and fire print 
			if ( window.parent )
			{	
				window.parent.VE_MessageControl._RemoveMessage();
				window.parent.hiddenIframeForPrintDirections.focus();
				window.parent.hiddenIframeForPrintDirections.print();								
			}					
		}
		else
		{	
			//TODO : not sure if we need to call ClearPrintLogCache()
			//ClearPrintLogCache();
			window.print();									
			//ClearPrintLogCache();
		}
		
	}	
	
	function OnCancelClick(e)
	{
		window.close();
	}
	
	function OnMapResizeSmall(e)
	{
		SetMapSizeSmall();	
	}
	
	function OnMapResizeMedium(e)
	{
		SetMapSizeMedium();
	}
	
	function OnMapResizeLarge(e)
	{
		SetMapSizeLarge();
	}
	
	function OnShowStartInstructionOnly(e)
	{
		SetShowStartInstructionOnly();
	}
	
	function OnShowEndInstructionOnly(e)
	{
		SetShowEndInstructionOnly();		
	}
	
	function OnShowAllInstructions(e)
	{
		SetShowAllInstructions();
	}
	
	function OnNotesToggle(e)
	{
		ToggleNotes();
	}
	function OnDirectionCheckboxClick(e)
	{
		ToggleAllDirectionSteps();
	}
	
	function OnScratchPadCheckboxClick(e)
	{
		ToggleAllScratchPadItems();
	}
	
	function OnCollectionCheckboxClick(e)
	{
		ToggleAllCollectionItems();
	}
	
	function OnSearchCheckboxClick(e)
	{
		ToggleAllSearches();
	}
	
	function OnSummaryToggle(e)
	{
		if(document.getElementById("toggleSummaryBox").checked)
		{
			SetShowSummary();
		}
		else
		{
			SetHideSummary();
		}
		UpdatePageBreaks();
	}
	
	function OnToggleArialLabels(e)
	{
		var mapStyle = overviewMap.GetMapStyle();
		if (mapStyle == 'a')
		{
			SetShowArialLabels();
		}
		else if (mapStyle == 'h')
		{
			SetHideArialLabels();
		}
	}
	
	function OnAllPresetClicked(e)
	{
		enableUpdatePageBreaks = false;
		ShowOverviewMap();
		ShowAllDirectionSteps();
		SetShowAllInstructions();
		SetMapSizeMedium();
		SetShowSummary();
		ShowAllScratchPadItems();
		ShowAllCollectionItems();
		ShowAllSearches();
		ShowNotes();
		currentPreset = "all";
		enableUpdatePageBreaks = true;
		UpdatePageBreaks();
	}
	
	function OnOnlyMapPresetClicked(e)
	{
		enableUpdatePageBreaks = false;
		ShowOverviewMap();
		SetMapSizeLarge();
		SetHideSummary();
		HideAllDirectionSteps();
		HideAllScratchPadItems();
		HideAllCollectionItems();
		HideAllSearches();
		HideNotes();
		currentPreset = "mapOnly";
		enableUpdatePageBreaks = true;
		UpdatePageBreaks();
	}
	
	function OnOnlyDirectionPresetClicked(e)
	{
		enableUpdatePageBreaks = false;
		HideOverviewMap();
		ShowAllDirectionSteps();
		SetShowAllInstructions();
		HideAllTurnByTurnMaps();
		HideNotes();
		SetShowSummary();
		ShowAllScratchPadItems();
		ShowAllCollectionItems();
		ShowAllSearches();
		currentPreset = "directionsOnly";
		enableUpdatePageBreaks = true;
		UpdatePageBreaks();
	}
	
	function OnNotesKeyUp(e)
	{
		document.getElementById("printableNotes").innerHTML = FormatNotes(document.getElementById("notesText").value);
	}
	
	/**
	  * because we are replacing the textarea with a div when printing 
	  * we need to respect line feed / line break characters and use breaking html tags
	  */
	function FormatNotes(notes)
	{	
		return notes.replace(new window.RegExp("[\\n\\r]+","g"),"<br/>");
	}
	
	function OnOverviewMapZoomIn(e)
	{
		overviewMap.ZoomIn();
	}
	
	function OnOverviewMapZoomOut(e)
	{
		overviewMap.ZoomOut();
	}
	
	function FireDirectPrintAction()
	{
		if ( preSetPrintOption == null )
			return;
		
		if ( preSetPrintOption == PrintMapsAndDirections )
		{			
			OnAllPresetClicked();
			//Fire print job
			OnPrintClick();						
		}
		else if ( preSetPrintOption == PrintMapsOnly )
		{
			OnOnlyMapPresetClicked();
			//Fire print job
			OnPrintClick();
		}
		else if ( preSetPrintOption == PrintDirectionsOnly )
		{
			OnOnlyDirectionPresetClicked();							
			//Fire print job
			OnPrintClick();
		}				
	}

	//Setup event handlers
	document.getElementById("roadStyleLink").attachEvent("onclick",OnRoadStyleClick);
	document.getElementById("arialStyleLink").attachEvent("onclick",OnArialStyleClick);
	
	document.getElementById("topPrint").attachEvent("onclick",OnPrintClick);
	document.getElementById("bottomPrint").attachEvent("onclick",OnPrintClick);
	
	document.getElementById("topCancel").attachEvent("onclick",OnCancelClick);
	document.getElementById("bottomCancel").attachEvent("onclick",OnCancelClick);
	
	document.getElementById("smallMapSizeLink").attachEvent("onclick",OnMapResizeSmall);
	document.getElementById("mediumMapSizeLink").attachEvent("onclick",OnMapResizeMedium);
	document.getElementById("largeMapSizeLink").attachEvent("onclick",OnMapResizeLarge);
	
	if (printRoute)
	{
		document.getElementById("showStartLink").attachEvent("onclick",OnStartClick);
		document.getElementById("showEndLink").attachEvent("onclick",OnEndClick);
		document.getElementById("showEntireLink").attachEvent("onclick", OnEntireClick);

		document.getElementById("directionsStart").attachEvent("onclick",OnShowStartInstructionOnly);
		document.getElementById("directionsAll").attachEvent("onclick",OnShowAllInstructions);
		document.getElementById("directionsEnd").attachEvent("onclick",OnShowEndInstructionOnly);

		directionsCheckbox.attachEvent("onclick",OnDirectionCheckboxClick);
		document.getElementById("toggleSummaryBox").attachEvent("onclick",OnSummaryToggle);
	}
	if (scratchPadVisible)
	{
		scratchPadCheckbox.attachEvent("onclick",OnScratchPadCheckboxClick);
	}
	if (collectionVisible)
	{
		collectionCheckbox.attachEvent("onclick",OnCollectionCheckboxClick);
	}
	if (searchCount > 0)
	{
		searchCheckbox.attachEvent("onclick",OnSearchCheckboxClick);
	}

	document.getElementById("toggleNotesBox").attachEvent("onclick",OnNotesToggle);

	document.getElementById("arialLabelsToggle").attachEvent("onclick",OnToggleArialLabels);	
	
	document.getElementById("everythingOnPresetLink").attachEvent("onclick",OnAllPresetClicked);
	document.getElementById("overmapOnlyPresetLink").attachEvent("onclick",OnOnlyMapPresetClicked);
	document.getElementById("instructionsOnlyPresetLink").attachEvent("onclick",OnOnlyDirectionPresetClicked);
	
	document.getElementById("notesText").attachEvent("onkeyup",OnNotesKeyUp);
	
	//window.attachEvent("onbeforeprint",OnPrintClick);
}
/**
  *
  * Page onload entry point.
  */
function PrintableDirectionsMain(e) 
{	
	// Disable the omniture onclick event handler stuck to the body of the element.
	// This will get around the bug in their element type detection code.
	document.body.detachEvent("onclick", s.bc);

	s.linkInternalFilters="javascript:,.msn.";	
	s_account  = omnitureAccount;
	s.server   = location.hostname;
	s.pageName = "PrintableMap Page";
	s.channel  = "VirtualEarth";
	/* Product Name */
	s.prop1 = "VirtualEarth";
	/* Culture and Language */
	s.prop2 = locale;
	/* MapTheme */
	s.prop3 = "";
	/* ZoomLevel */
	s.prop4 = "";
	/* Region Code */
	s.prop5 = "";
	/* Navigation Action */
	s.prop6 = "";
	/* Navigation Control */
	s.prop7 = "";
	/* Search Keyword */
	s.prop8 = "";
	/* Search Location */
	s.prop9 = "";
	
	// File loaded in a new pop-up window		
	if ( window.opener )
	{	
		//set the usertype
		usertype = window.opener.usertype;
		
		printDirectionsManager = new VE_PrintableDirectionsManager(window.opener.map,
															window.opener.VE_Directions.displayedRoute,
															"overviewMapContainer",
															"directionsViewContainer",
															window.opener.scratchPad,
															window.opener.VE_CollectionsManager ? window.opener.VE_CollectionsManager.Viewer : null,
															window.opener.VE_SearchManager.searches,
															"scratchPadViewContainer",
															"collectionViewContainer",
															"searchViewContainer",
															window.opener.document);
															
	}
	// file loaded in an iframe window
	else if ( window.parent.map )
	{	
		//set the usertype
		usertype = window.parent.usertype;		
		
		//set the flag to identify if it is direct print job
		directPrintOption = true;		
		setTimerOption = true;
		
		printDirectionsManager = new VE_PrintableDirectionsManager(window.parent.map,
															window.parent.VE_Directions.displayedRoute,
															"overviewMapContainer",
															"directionsViewContainer",
															window.parent.scratchPad,
															window.parent.VE_CollectionsManager ? window.parent.VE_CollectionsManager.Viewer : null,
															window.parent.VE_SearchManager.searches,
															"scratchPadViewContainer",
															"collectionViewContainer",
															"searchViewContainer",
															window.parent.document);								
								
	}
	else return;	
}

function InvokeDirectPrintAction(value)
{		
	preSetPrintOption = value;
	if(printDirectionsManager) {printDirectionsManager.FireDirectPrintAction();}	
}

function Cleanup(e)
{
	if(printDirectionsManager) {printDirectionsManager.Destroy();}
	printDirectionsManager = null;
}

window.attachEvent("onload",LoadUI);
window.attachEvent("onunload",Cleanup);

////////////////////////////////////////////////////////////////
// temp utilty functions.
// TODO: remove after Cody refactors Modes code
function MetersPerPixel(z)
{
	//return baseMetersPerPixel >> z;
	return baseMetersPerPixel / (1 << z);
}

// Convert an X pixel coordinate to a longitude at a specified zoom level
function XToLonAtZ(x, z)
{
	var mpp = MetersPerPixel(z);
	var mx = x * mpp - offsetMeters;
	return RadToDeg(mx / earthRadius);
}

// Convert a longitude to an X pixel coordinate at a specified zoom level
function LonToXAtZ(longitude, z)
{
	var mx = earthRadius * DegToRad(longitude);
	var mpp = MetersPerPixel(z);
	return MathRound((mx + offsetMeters) / mpp);
}

// Convert a Y pixel coordinate to a latitude at a specified zoom level
function YToLatAtZ(y, z)
{
	var mpp = MetersPerPixel(z);
	var my = offsetMeters - y * mpp;
	return RadToDeg(Math.PI/2 - 2 * Math.atan(Math.exp(-my / earthRadius)));
}

// Convert a latitude to a Y pixel coordinate at a specified zoom level
function LatToYAtZ(latitude, z)
{
	var sinLat = Math.sin(DegToRad(latitude));
	var my = earthRadius/2 * Math.log((1 + sinLat) / (1 - sinLat));
	var mpp = MetersPerPixel(z);
	return MathRound((offsetMeters - my) / mpp);
}

// Convert an X pixel coordinate to a longitude at the current zoom level
function XToLon(x)
{
	return XToLonAtZ(x, currentView.zoomLevel);
}

// Convert a longitude to an X pixel coordinate at the current zoom level
function LonToX(longitude)
{
	return LonToXAtZ(longitude, currentView.zoomLevel);
}

// Convert a Y pixel coordinate to a latitude at the current zoom level
function YToLat(y)
{
	return YToLatAtZ(y, currentView.zoomLevel);
}

// Convert a latitude to a Y pixel coordinate at the current zoom level
function LatToY(latitude)
{
	return LatToYAtZ(latitude, currentView.zoomLevel);
}

// Converts an x coordinate to the x coordinate at a different zoom level
function XToXAtZ(x, z1, z2)
{
	var lon = XToLonAtZ(x, z1);
	return LonToXAtZ(lon, z2);
}

// Converts a y coordinate to a y coordinate at a different zoom level
function YToYAtZ(y, z1, z2)
{
	var lat = YToLatAtZ(y, z1);
	return LatToYAtZ(lat, z2);
}

// Determines if the user can zoom in with the currently set viewport
function ValidateZoomLevel(latitude, longitude, requestedZoom)
{
	if (requestedZoom < minZoom)
	{
		return minZoom;
	}
	
	var b = GetBoundsAtLatLong(latitude, longitude, requestedZoom);
	if (!b)
	{
		return minZoom;
	}
	
	return MathMin(b.z2, requestedZoom);
}

function GetBoundsAtLatLong(latitude, longitude, requestedZoom)
{
	var y = currentMode.LatToYAtZ(latitude, requestedZoom);
	var x = currentMode.LonToXAtZ(longitude, requestedZoom);
	return GetBounds(x, y, requestedZoom);
}

function GetBounds(x, y, requestedZoom)
{
	if (requestedZoom == undefined)
	{
		requestedZoom = currentView.zoomLevel;
	}
	
	if (x == undefined || y == undefined)
	{
		y = currentMode.LatToYAtZ(currentView.center.latitude, requestedZoom);
		x = currentMode.LonToXAtZ(currentView.center.longitude, requestedZoom);
	}

	var bestZoom = minZoom;
	var bestBounds = null;
	
	for (var i=0; i<bounds.length; i++)
	{
		var deltaZ = requestedZoom - bounds[i].z1;
		var factor = tileSize * Math.pow(2, deltaZ);
		var minX = bounds[i].x1 * factor;
		var maxX = bounds[i].x2 * factor;
		var minY = bounds[i].y1 * factor;
		var maxY = bounds[i].y2 * factor;
		
		if (x >= minX && x <= maxX && y >= minY && y <= maxY)
		{
			if (bounds[i].z2 > bestZoom)
			{
				bestZoom = bounds[i].z2;
				bestBounds = bounds[i];
			}
		}
	}
	
	return bestBounds;
}


//Creates a bound for the given params
//
function Rect(x,y,width,height)
{
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
}

Rect.prototype.IsInBounds=function(x,y)
{
	return (x < (this.x+this.width) && 
	        x > this.x &&
	        y < (this.y+this.height) && 
			y > this.y);
	
};
Rect.prototype.toString=function()
{
	return "{x="+this.x+",y="+this.y+",width="+this.width+",height="+this.height+"}";	
};

//
// determine whether the latitude and longitude passes as parameters
// are within the bounds constructed using centerLat,centerLong and width and height.
//
function IsLatLongInRect(width,height,centerLat,centerLong,latitude,longitude,zoom)
{
	var x = LonToXAtZ(centerLong,zoom) - width/2;
	var y = LatToYAtZ(centerLat,zoom) - height/2;
	
	var checkX = LonToXAtZ(longitude,zoom);
	var checkY = LatToYAtZ(latitude,zoom);
	
	var mapRect = new Rect(x,y,width,height);
	
	return mapRect.IsInBounds(checkX,checkY);

}

function GetCssRulesForStylesheet(styleSheet)
{
	if (styleSheet == null)
	{
		return null;
	}
	
	if (styleSheet.rules)
	{
		return styleSheet.rules;
	}
	else if (styleSheet.cssRules)
	{
		return styleSheet.cssRules;
	}
	
	return null;
}
