// Copyright 2005 Microsoft Corporation
// Version number : 1.3.0519
//------------------------------------------------------------------------------
//	VE.Feature.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-pratin
//
// <header>	$Header$</header>
//-----------------------------------------------------------------------------
//Localizable Strings
var L_VEProductName_Text = "[+++袢啓厓Windows Live Local十汁十汁十+++]";	

// RegisterNamespace
RegisterNamespaces("Msn.VE");

Msn.VE.Features = new function()
{
	// Product name 
	this.ProductName = L_VEProductName_Text;

	//Settings Dialog options
	this.Settings = new function()
	{
		this.SaveLastLocation = true; 
		this.SaveSearches = false; 
		this.SaveScratchpad = true; 
		this.UseAnimatedPanZoom = true; 
		this.InstallLocationFinderNotification = false; 
	}
	// Footer links
	this.Footer = new function()
	{
		this.About = true;
		this.Privacy = true;
		this.Developers = true;
		this.Help = true;
		this.Feedback = true;
	}
	
	//Search categories
	this.Search = new function()
	{
		this.Categories = true;
	}	
	
	//Header links
	this.Header = new function()
	{
		this.Help = true;
		this.Settings = true;
	}
	
	//Map Action bar
	this.MapAction = new function()
	{
		this.Welcome = true;
		
		this.Collections = new function()
		{
			this.DisplayNone = false;
			this.Open = true;
			this.New = true;
			this.AddPushpin = (this.DisplayNone) ? false : true;
			this.Favorites = true;			
		}
		
		this.DrivingDirections = true;
		this.Traffic = true;	
		this.LocateMe = true;	
		
		this.Share = new function()
		{
			this.ShareInMessenger = true;			
			this.EmailPermalink = true;					// E-mail
			this.CopyToClipboard = true;			
			this.AddBlogEntry = true;
			this.ViewPermalink = true;
			this.DisplayNone = false;
		}
	}
	
	//Context menu / pop-up	
	this.MenuOption = new function()
	{
		this.ZoomToStreet = true;
		this.ZoomToCity = true;
		this.ZoomToRegion = true;
		this.CenterMapHere = true;
		this.SendEmailOnPushpinItem = true;
		this.SendEmailOnSearchItem = true;
		this.DetailsOnSearchItem = true;
	
		//Scratch Pad Panel menu	
		this.ShareScratchPadItems = new function()
		{
			this.SendIM = false;
			this.SendEmail = true;
			this.CopyToClipboard = true;
			this.AddBlogEntry = true;				
			this.DisplayNone = false;		
		}
		
		this.MapAllScratchPadItems = true;
		
		//Driving Direction Panel menu
		this.ShareDrivingDirections = new function()
		{
			this.SendEmail = true;
			this.CopyToClipboard = true;
			this.SendIM = true;
			this.DisplayNone = false;		
		}
		
		this.PrintDrivingDirections = new function()
		{
			this.Customized = true;			
			this.MapsOnly = true;
			this.MapsAndDirectionsOnly = true; 
			this.DirectionsOnly = true;			
			this.DisplayNone = false;		
		}
	}
	//Traffic flow Strings
	this.Traffic = new function()
	{
		this.Flow = new function()
		{
			this.Slow = "0-25 mph";
			this.Moderate = "25-45 mph";
			this.Fast = "45+ mph";
		}	
		
		this.Attribution = "Traffic data provided by Traffic.com";
	}
	//Click2Call feature
	this.Click2Call = new function()
	{
		this.Enabled = false;
		this.CountryList = new Array();
	}
	
	this.Ads = new function()
	{	
		//Overture, Telco, OvertureCA, Thompson
		this.AttributionTextOverture = "Sponsors From Overture";
		this.AttributionTextTelco = "Sponsors From Superpages";
		this.AttributionTextOvertureCA = ""; //left blank intentionally
		this.AttributionTextThompson = "Sponsors from ThompsonLocal.com";
	}	
}

//------------------------------------------------------------------------------
// Error.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-pratin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

function RegisterNamespaces()
{
	for (var i=0;i<arguments.length;i++)
	{
		var astrParts = arguments[i].split(".");
		var root = window;
		for (var j=0; j < astrParts.length; j++)
		{
			if (!root[astrParts[j]]) 
			{
				root[astrParts[j]] = new Object(); 
			}
			root = root[astrParts[j]];
		}
	}
}
			
function onLoad()
{	
	window.document.title = Msn.VE.Features.ProductName;
}
