//------------------------------------------------------------------------------
// util/Time.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-jayab
//
// <header>	$Network$</header>
//------------------------------------------------------------------------------

//Network class
function VETime()
{	
}

//Formatting the time to show only mm/dd hh/mm
VETime.FormatTime = function(time, is12HourFormat)
{		
	//03/06/2006 05:01:00 AM
	if(time == null || time == "" || time == "undefined")
		return "";
		
	var isAm = false;	
	var d = time.substr(0, 10);
	var t = time.substr(11, 5);
	var ap = "";
	if(time.indexOf("AM") > -1)
	{
		ap = "AM";
		isAm = true;
	}
	else
	{
		ap = "PM";
	}
	return d + " " + VETime.ConvertTo12HourFormat(t, isAm) + " " + ap;
}

VETime.ConvertTo12HourFormat = function(time, isAM)
{
	var returnValue = time;
	try
	{
		var value = parseFloat(returnValue.replace(":", "."));
		if(value > 12)
		{
			if(value < 13 && isAM != true)
			{
				//Do nothing
			}
			else
			{
				value = value - 12;			
			}
		}
		returnValue = value.toFixed(2);
		returnValue = returnValue.replace(".", ":");
	}
	catch(ex)
	{
		returnValue = "";
	}	

	return returnValue;
}

//Formatting the time to show only mm/dd hh/mm
VETime.FormatPanelTime = function(time, includeDate)
{
	if(time == null || time == "" || time == "undefined")
		return "";
	try
	{
		var apindex = 0;
		var isAm = false;
		var d = time.substr(4, 8);
		var tindex = time.indexOf(":");
		var t = time.substr(tindex-2, 5);
		var ap = "";
		if(time.indexOf("AM") > -1)
		{
			ap = "AM";
			isAm = true;
			apindex = time.indexOf("AM");
		}
		else
		{
			ap = "PM";
			apindex = time.indexOf("PM");			
		}
		var tz = "";
		if(apindex > 0)
			tz = time.substr(apindex+3, 3);
		if( includeDate )
			return  d + " " + VETime.ConvertTo12HourFormat(t, isAm) + " " + ap + " " + tz;
		else
			return  VETime.ConvertTo12HourFormat(t, isAm) + " " + ap + " " + tz;
	}
	catch(ex)
	{
		
	}
}

VETime.getMonth = function(month)
{
	switch(month)
	{
		case "01":
			return " Jan";
			break;
		case "02":
			return " Feb";
			break;
		case "03":
			return " Mar";
			break;
		case "04":
			return " Apr";
			break;
		case "05":
			return " May";
			break;
		case "06":
			return " Jun";
			break;
		case "07":
			return " Jul";
			break;
		case "08":
			return " Aug";
			break;
		case "09":
			return " Sep";
			break;
		case "10":
			return " Oct";
			break;
		case "11":
			return " Nov";
			break;
		case "12":
			return " Dec";
			break;
	}
}

