window.addEventListener('load', init, false);

function init()
{				
	window.__included__ = new Array();	
	
	ifFileExists('./config.txt', processConfigFile);
}

function processConfigFile(_responseText)
{	
	var classNames = _responseText.split(',');
	var i;
	for (i = 0; i < classNames.length; i++)
	{
		var className = classNames[i];		
		
		ifFileExists('./' + className + '.js', includeProxy(className));
	}
}

function includeProxy(_className)
{
	return function(_responseText)
	{
		include(_className, _responseText);
		createObjects(_className);		
	}
}

function createObjects(className)
{
	var elems = getElementsByClassName(className);
				
	var j;
	for (j = 0; j < elems.length; j++)
	{
		var elem = elems[j];
		var params = elem.getAttribute('params');		
		var evalStr = 'var tmp = new ' + className + '(' + params + ');';		
		eval(evalStr);
		elems[j].appendChild(tmp.getElement());			
	}
}

function ifFileExists(_file, _callback)
{
	var xReq = new XMLHttpRequest();
	xReq.open('GET', _file, true);	
	xReq.send(null);
	
	xReq.onreadystatechange = function()
	{
		if (xReq.readyState == 4)
		{
			if (xReq.status == 200)
			{
				if (typeof _callback == 'function')
					{	_callback(xReq.responseText); }				
			}
		}
	}
}

function include(_id, _fileData)
{
	if (window.__included__[_id] == 'included')
		{ return; }
	
	window.__included__[_id] = 'included';
	
	//var script = document.createElement('script');
	//script.setAttribute('type', 'text/javascript');
	//script.appendChild(document.createTextNode(_fileData));
	
	//var head = document.getElementsByTagName('head');
	//head[0].appendChild(script);	
	eval(_fileData);	
}

function getElementsByClassName(_className)
{
	var arr = new Array();				
	
	var allElements = document.getElementsByTagName('*');
	
	var i;
	for (i = 0; i < allElements.length; i++)
	{
		var elem = allElements[i];
		
		if (elem.className == _className)
			{ arr.push(elem); }
	}
	
	return arr;
}
