using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Net;

namespace VEProxy
{
	
	public class WebForm1 : System.Web.UI.Page
	{
		private string flight;
		private WebResponse res;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}
		
		override protected void OnInit(EventArgs e)
		{
			string url = "http://localhost/";
			
			flight = Request.QueryString["flight"];
			Session["flight"] = flight;
			if (flight == null || flight == string.Empty)
				return;
				
			url += "flight" + flight;
			
			HttpWebRequest req = (HttpWebRequest)WebRequest.Create(url);
			res = req.GetResponse();
			
			InitializeComponent();
			base.OnInit(e);
		}		
		
		protected override void Render(HtmlTextWriter writer)
		{
			if (flight != null && flight != string.Empty)
			{
				Response.Clear();
				Response.ContentType = res.ContentType;
				
				Uri uri = HttpContext.Current.Request.Url;
				string path = uri.GetLeftPart(UriPartial.Path);			
				string domain = path.Replace(uri.Segments[uri.Segments.Length - 1], "").Replace(":97", "");
				domain = domain.Replace("veproxy/", "flight" + flight + "/");
				
				System.IO.StreamReader sr = new System.IO.StreamReader(res.GetResponseStream(), System.Text.Encoding.UTF8);
				string str = sr.ReadToEnd();
				str = str.Replace("\"/", "\"" + domain);
				str = str.Replace("'/", "'" + domain);
				str = str.Replace("=/", "=" + domain);
				str = str.Replace("./", domain);
				str = str.Replace("../", domain);
				str = str.Replace("../../", domain);
				writer.Write(str);
				res.Close();
			}
			else
			{		
				base.Render (writer);
			}
		}

		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}		
	}
}
