//------------------------------------------------------------------------------
// Annotation/AnnotationConf.js - Configuration and construction of the
//                                 Annotations framework
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: BayardB
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

//
// the height of the annotations panel + 34 for titlebar
VE_Annotations.PanelHeight = 234;
//
// the width of the annotations panel
VE_Annotations.PanelWidth = 220;
//
// the color of the annotations panel
VE_Annotations.PanelColor = "blue";
//
// the color of the annotations popup
VE_Annotations.PopupColor = "blue";
//
// the title of the annotations creation panel
VE_Annotations.CreateTitle = L_AnnotationConfCreateTitle_Text; 
//
// the title of the annotations edit panel
VE_Annotations.EditTitle = L_AnnotationConfEditTitle_Text; 
//
// the height of the annotations panel + 34 for titlebar
VE_Annotations.PopupHeight = 234;
//
// the width of the annotations panel
VE_Annotations.PopupWidth = 220;
//
// the title of the annotations popup
VE_Annotations.PopupTitle = L_AnnotationConfPopupTitle_Text;
//
// the default title of a new pushpin
VE_Annotations.DefaultTitle = L_AnnotationConfDefaultTitle_Text;
//
// the default note for a new pushpin
VE_Annotations.DefaultNote = "";
//
// the default infoUrl for a new pushpin
VE_Annotations.DefaultInfoUrl = "";
//
// the default infoUrl for a new pushpin
VE_Annotations.DefaultPhotoUrl = "";
//
// the pin type of an annotation pin
VE_Annotations.PinType = "aN";
//
// the minimum number of chars allowed in the Title field
VE_Annotations.MinTitleChars = 1;
//
// the max number of chars allowed in the Title field
VE_Annotations.MaxTitleChars = 100;
//
// the minimum number of chars allowed in the Notes field
VE_Annotations.MinNotesChars = 0;
//
// the max number of chars allowed in the Notes field
VE_Annotations.MaxNotesChars = 200;

VE_Annotations.ScratchPadFullMsg = L_AnnotationConfScratchPadFullText1_Text + "<br>"
	+ L_AnnotationConfScratchPadFullText2_Text.replace(/%1/g, '<a href="" onclick="showSaveUI(false);VE_MessageControl.Hide();return false;">' ).replace(/%2/g,'</a>');
	
//
// construct an annotation object
function VE_Annotations ()
{
}
