//------------------------------------------------------------------------------
// MapControl/PixelRectangle.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

Msn.VE.PixelRectangle = function(topLeft, bottomRight)
{
	this.topLeft = topLeft;
	this.bottomRight = bottomRight;
	
	this.ToString = function()
	{
		return "(" + (this.topLeft ? this.topLeft.ToString() : "null") + ", " + (this.bottomRight ? this.bottomRight.ToString() : "null") + ")";
	};
	
	this.Copy = function(rect)
	{
		if (!rect)
		{
			return;
		}
		
		if (!this.topLeft)
		{
			this.topLeft = new Msn.VE.Pixel();
		}
		
		if (!this.bottomRight)
		{
			this.bottomRight = new Msn.VE.Pixel();
		}
		
		this.topLeft.Copy(rect.topLeft);
		this.bottomRight.Copy(rect.bottomRight);
	};
};

