//------------------------------------------------------------------------------
// Passport.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: kamonmo
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------
function VE_Passport()
{
}
VE_Passport.maxPassportCookieAge = 8;
VE_Passport.passportExpiredTime;
VE_Passport.isAuthenticated = false;

VE_Passport.CheckSignedInUrl = "UserCollections.aspx?action=CheckSignIn";

VE_Passport.CheckPassportSignedIn = function(signedInCallback,notSignedInCallback) 
{
	var checkRequired = VE_Passport.CheckSignedInRequired();
	if(checkRequired) 
	{
		var xmlhttp = GetXmlHttp();
		if(xmlhttp)
		{
			var url = VE_Passport.CheckSignedInUrl;
			xmlhttp.open("GET", url, true);
			xmlhttp.onreadystatechange = function()
			{
				if(xmlhttp.readyState==4) 
				{
					if (xmlhttp.status==200)
					{
						var code = xmlhttp.responseText;
						var isSignedIn = false;
						try
						{
							isSignedIn = eval(code);
						}
						catch(ex){	}
						VE_Passport.isAuthenticated = isSignedIn;
						if(isSignedIn) 
						{						
							if(signedInCallback) 
							{
								signedInCallback();
							}
						} 
						else 
						{
							if(notSignedInCallback)
							{
								notSignedInCallback();
							}
						}
					} 
					else 
					{
						//if something goes wrong we act as user is not signed in
						if(notSignedInCallback)
						{
							notSignedInCallback();
						}
					}
				}
			};
			xmlhttp.send("");
		}
	} else {
		if(VE_Passport.isAuthenticated) 
		{						
			if(signedInCallback) 
			{
				signedInCallback();
			}
		} 
		else 
		{
			if(notSignedInCallback)
			{
				notSignedInCallback();
			}
		}
	}
}

VE_Passport.CheckPassportSignedInSync = function() 
{
	var checkRequired = VE_Passport.CheckSignedInRequired();
	if(checkRequired) 
	{
		var xmlhttp = GetXmlHttp();
		if(xmlhttp)
		{
			var url = VE_Passport.CheckSignedInUrl;
			xmlhttp.open("GET", url, false);
			xmlhttp.send("");
			if (xmlhttp.status==200)
			{
				var code = xmlhttp.responseText;
				var isSignedIn = false;
				try
				{
					isSignedIn = eval(code);
				}
				catch(ex)
				{	
					//swallow
				}			
				VE_Passport.isAuthenticated = isSignedIn;
				return(isSignedIn);
			}  
			else 
			{
				return(false);
			}
		}
	} else 
	{
		return(VE_Passport.isAuthenticated);
	}
}
VE_Passport.CheckSignedInRequired = function()
{
	var now = new Date();
	if(now >= VE_Passport.passportExpiredTime) 
	{
		VE_Passport.isAuthenticated = false;
	}
	return(!passportReturned);
}
