﻿//------------------------------------------------------------------------------
// API Resources.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Cthota, keithkin
//
// <header>	$Resources$</header>
//------------------------------------------------------------------------------
//Resources
var L_invalidinvoketarget_text = "Invalid invoke target specified.";
var L_invaliddirections_text = "Invalid argument passed; both start and end must be present.";
var L_invalidpageindex_text = "Invalid search results page index is passed.";
var L_invalidelement_text = "Invalid element id; unable to find the element in the document body.";
var L_noheadelement_text = "Head element is missing for the current document; cannot initialize the API framework.";
var L_noserviceurl_text = "Either a service url or script url is required to create VENetwork instance.";
var L_noscripturl_text = "Invalid script source url is assigned; cannot download the assigned script.";
var L_nostylesurl_text = "Invalid style source url is assigned; cannot attach the assigned styles.";
var L_invalidwhatwhere_text = "Invalid what/where parameters; either 'what' or 'where' must be present.";
var L_notinitialized_text = "Map is not loaded; cannot perform this operation.";
var L_noroute_text = "Cannot calculate route at this point; try again later.";
var L_invalidpushpin_text = "Invalid pushpin instance.";
var L_invalidpushpinid_text = "Invalid pushpin id; either id is empty or another pushpin already exists with that id.";
var L_invalidpolylineid_text = "Invalid polyline id; either id is empty or another polyline already exists with that id.";
var L_invalidargument_text = "Invalid argument; input argument '%1' is not a valid '%2' value."; //%1 is a variable name that is input to a function, %2 is a variable type
var L_invalidlayerid_text = "Invalid layer id; either id is empty or another layer already exists with that id.";
var L_invalidlayertype_text = "Invalid layer type.";
var L_invalidlayersource_text = "Invalid layer source; either layer is empty or does not exist.";
var L_Help_Text = "Help";
var L_ErrorServerBusy_Text = "The server is currently busy. Try again later.";

var L_error_text = "Error";
var L_close_text = "close";
var L_what_text = "What";
var L_where_text = "Where";
var L_find_text = "Find";
var L_selectlocation_text = "Select a location";
var L_Start_Text = "Start";
var L_End_Text = "End";
var L_DirectionsGetDirections_Text = "Get directions";
var L_loading_text = ".. Loading ..";
var L_arriveat_text = "Arrive at";
var L_startat_text = "Start at";
var L_step_text = "Step %1 of %2"; //%1 is a number indicating the step number in the Driving Route, %2 is the total number of steps in the Driving Route
var L_DirectionsStep_Text = 'Step';

//Collections manager strings - required for API to work
var L_CollectionManagerViewerDefaultTitle_Text = "Shared Collection";
var L_CollectionManagerUnsavedCollectionTitle_Text = "Unsaved Collection";