//------------------------------------------------------------------------------
// Search/SearchPaging.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, sstchur
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Move the top search forward 1 page
VE_SearchManager.PageForward=function(index)
{
	if(VE_SearchManager.searching)
	{
		return;
	}

	VE_SearchManager.CloseSearchPopup();
	var s = VE_SearchManager.FindByIndex(index);
	
	if(s.displayIndex + VE_SearchManager.displayCount >= VE_SearchManager.requestCount)
	{
		s.startIndex += VE_SearchManager.requestCount;
		s.displayIndex = 0;
		VE_SearchManager._DoSearch("", false);
	}
	else
	{
		s._ClearPins();
		s.displayIndex += VE_SearchManager.displayCount;
		s._UpdatePins();
		s._UpdatePanel();
	}
	
	// Reset the scroll position of the search panel's body <div> to (0, 0)
	setScrollPosition(s.panel.body, 0, 0);
}


// Move the top search backward 1 page
VE_SearchManager.PageBackward=function(index)
{
	if(VE_SearchManager.searching)
	{
		return;
	}
	
	VE_SearchManager.CloseSearchPopup();
	var s = VE_SearchManager.FindByIndex(index);
	if(s.displayIndex == 0)
	{
		if(s.startIndex > 0)
		{
			s.startIndex -= VE_SearchManager.requestCount;
			s.displayIndex = VE_SearchManager.requestCount - VE_SearchManager.displayCount;
			VE_SearchManager._DoSearch("", false);
		}
	}
	else
	{
		s._ClearPins();
		s.displayIndex -= VE_SearchManager.displayCount;
		s._UpdatePins();
		s._UpdatePanel();
	}
	
	// Reset the scroll position of the search panel's body <div> to (0, 0)
	setScrollPosition(s.panel.body, 0, 0);
}

