window.addEventListener('load', init, false);

function init()
{				
	window.__included__ = new Array();	
	var classNames = include('./config.txt', true);
	
	var i;
	for (i = 0; i < classNames.length; i++)
	{
		var className = classNames[i];		
		include('./' + className + '.js');
		
		var elems = getElementsByClassName(className);
		
		var j;
		for (j = 0; j < elems.length; j++)
		{
			var elem = elems[j];
			var params = elem.getAttribute('params');
			var evalStr = 'var tmp = new ' + className + '(' + params + ');';
			eval(evalStr);
			elems[j].appendChild(tmp.getElement());			
		}
	}
}

function include(_id, _configFile)
{
	if (window.__included__[_id])
		{ return; }
		
	window.__included__[_id] = true;
	
	var xReq = new XMLHttpRequest();
	xReq.open('GET', _id, false);
	xReq.send(null);
			
	var responseText = xReq.responseText;
	
	if (_configFile)
	{
		var classes = responseText.split(',');
		return classes;
	}
	else
	{
		var script = document.createElement('script');
		script.setAttribute('type', 'text/javascript');
		script.appendChild(document.createTextNode(responseText));
		
		var head = document.getElementsByTagName('head');
		head[0].appendChild(script);
	}
}

function getElementsByClassName(_className)
{
	var arr = new Array();				
	
	var allElements = document.getElementsByTagName('*');
	
	var i;
	for (i = 0; i < allElements.length; i++)
	{
		var elem = allElements[i];
		
		if (elem.className == _className)
			{ arr.push(elem); }
	}
	
	return arr;
}
